--[[
	Define all Global Variables here
]]

-- Global Variables that are not supposed to be on-the-fly user configurable.
perl_locked		= 1;

function Perl_ShowMessage(cMsg)
	local str = "|c00FF7F00"..event.."|r";
	if (arg1) then
		str = str..", "..arg1;
		if (string.find(arg1, "raid") or string.find(arg1, "party") or string.find(arg1, "player") or string.find(arg1, "pet") or string.find(arg1, "target")) then
			str = str.."("..UnitName(arg1)..")";
		end
	end

	str = str..", "..(arg2 or "")
	str = str..", "..(arg3 or "")
	str = str..", "..(arg4 or "")
	str = str..", "..(arg5 or "")
	str = str..", "..(arg6 or "")
	str = str..", "..(arg7 or "")
	str = str..", "..(arg8 or "")
	str = str..", "..(arg9 or "")

	if (cMsg) then
		str = cMsg.." - "..str;
	end

	ChatFrame7:AddMessage("|c00007F7F"..this:GetName().."|r - "..str);
end

function Perl_Notice(str)
	if (DEFAULT_CHAT_FRAME) then
		DEFAULT_CHAT_FRAME:AddMessage(Perl_ProductName.." - |c00B03030"..str);
	end
end

function Perl_SetMyGlobal()
	if (Perl_Config_SavePerCharacter) then
		if (not Perl_Config_Global) then
			Perl_Config_Global = {};
		end

		if (not Perl_Config_Global[GetRealmName()]) then
			Perl_Config_Global[GetRealmName()] = {};
		end

		Perl_Config_Global[GetRealmName()][UnitName("player")] = Perl_Config;
	else
		if (Perl_Config_Global[GetRealmName()][UnitName("player")]) then
			Perl_Config = Perl_Config_Global[GetRealmName()][UnitName("player")];
		end
	end
end

local function DefaultVar(name, value)
	if (Perl_Config[name] == nil or (type(value) ~= type(Perl_Config[name]))) then
		Perl_Config[name] = value;
	end
end

function Perl_Defaults()

	DefaultVar("BarTextures",		1);
	DefaultVar("Transparency",		0.8);
	DefaultVar("TextTransparency",		1);
	DefaultVar("BackColour",		{r = 0, g = 0, b = 0, a = 1});
	DefaultVar("BorderColour",		{r = 0.5, g = 0.5, b = 0.5, a = 1});
	if (not Perl_Config.BackColour.a) then
		Perl_Config.BackColour.a = 1
	end
	if (not Perl_Config.BorderColour.a) then
		Perl_Config.BorderColour.a = 1
	end

	DefaultVar("ArcaneBar",			1);
	DefaultVar("OldCastBar",		1);
	DefaultVar("CastTime",			1);
	DefaultVar("ClassColouredNames",	1);
	DefaultVar("HighlightSelection",	1);
	DefaultVar("MinimapButtonPosition",	186);
	DefaultVar("MinimapButtonShown",	1);
	DefaultVar("PerlCombatFlash",		1);
	DefaultVar("PerlFadeFrames",		1);
	DefaultVar("CombatHitIndicator",	1);
	DefaultVar("HighlightDebuffs",		1);
	DefaultVar("HighlightDebuffsBorder",	1);
	DefaultVar("BuffTooltipHelper",		1);
	DefaultVar("HealerMode",		0);
	DefaultVar("FatHealthBars",		1);
	DefaultVar("MaximumScale",		1.5);

	DefaultVar("ClassicHealthBar",		1);
	DefaultVar("ColourHealthEmpty",		{r = 1, g = 0, b = 0});
	DefaultVar("ColourHealthFull",		{r = 0, g = 1, b = 0});
	DefaultVar("ColourMana",		{r = 0, g = 0, b = 1});
	DefaultVar("ColourEnergy",		{r = 1, g = 1, b = 0});
	DefaultVar("ColourRage",		{r = 1, g = 0, b = 0});
	DefaultVar("ColourFocus",		{r = 1, g = 0.5, b = 0.25});

	-- Player options
	DefaultVar("ShowPlayerPortrait",	1);
	DefaultVar("ShowPlayerPortrait3D",	1);
	DefaultVar("ShowPlayerLevel",		1);
	DefaultVar("ShowPlayerClassIcon",	1);
	DefaultVar("ShowPlayerXPBar",		0);
	DefaultVar("ShowPlayerPVPRank",		1);
	DefaultVar("ShowPlayerValues",		1);
	DefaultVar("ShowPlayerPercent",		1);
	DefaultVar("Scale_PlayerFrame",		0.8);
	DefaultVar("ShowPartyNumber",		1);
	DefaultVar("EnergyTicker",		1);

	-- Player Pet
	DefaultVar("ShowPlayerPetPortrait",	1);
	DefaultVar("PetHappiness",		1);
	DefaultVar("PetHappinessSad",		1);		-- Only show happiness when not happy
	DefaultVar("PetFlashWhenSad",		1);
	DefaultVar("ShowPetLevel",		1);
	DefaultVar("Scale_PetFrame",		0.8);
	DefaultVar("ShowPetXP",			1);
	DefaultVar("ShowPlayerPetName",		1);
	DefaultVar("PlayerPetBuffSize",		20);

	-- Target
	DefaultVar("ShowTargetPortrait",	1);
	DefaultVar("ShowTargetClassIcon",	1);
	DefaultVar("ShowTargetMobType",		1);
	DefaultVar("ShowTargetLevel",		1);
	DefaultVar("ShowTargetElite",		1);
	DefaultVar("ShowTargetMana",		1);
	DefaultVar("ShowTargetPercent",		1);
	DefaultVar("ShowTargetValues",		1);
	DefaultVar("UseCPMeter",		1);
	DefaultVar("BlizzardCPMeter",		0);
	DefaultVar("ShowTargetPVPRank",		1);
	DefaultVar("Show30YardSymbol",		1);
	DefaultVar("Scale_TargetFrame",		0.8);
	DefaultVar("AlternateRaidIcon",		1);
	DefaultVar("TargetBuffSize",		22);
	DefaultVar("TargetBuffRows",		3);
	DefaultVar("TargetBuffsAbove",		0);

	-- Target's Target
	DefaultVar("ShowTargetTarget",		1);
	DefaultVar("TargetTargetHistory",	0);
	DefaultVar("ShowTargetTargetTarget",	1);
	DefaultVar("TargetTargetBuffs",		1);
	DefaultVar("TargetCastableBuffs",	0);
	DefaultVar("TargetCurableDebuffs",	0);
	DefaultVar("TargetTargetTargetBuffs",	1);
	DefaultVar("Scale_TargetTargetFrame",	0.8);
	DefaultVar("ShowTargetTargetPercent",	1);
	DefaultVar("ShowTargetTargetValues",	1);
	DefaultVar("ShowTargetTargetLevel",	1);
	DefaultVar("ShowTargetTargetMana",	1);
	DefaultVar("TargetTargetBuffsAbove",	0);

	-- Cast Party
	DefaultVar("CastParty",			1);
	DefaultVar("CastPartyShow",		0);
	DefaultVar("CastPartyRaidOnly",		0);		-- Cast Party works on raid frame only?

	-- Party
	DefaultVar("ShowPartyPortrait",		1);
	DefaultVar("ShowPartyTarget",		1);
	DefaultVar("ShowPartyLevel",		1);
	DefaultVar("ShowPartyNames",		1);
	DefaultVar("ShowPartyValues",		1);
	DefaultVar("ShowPartyPercent",		1);
	DefaultVar("ShowPartyClassIcon",	1);
	DefaultVar("ShowPartyRaid",		1);
	DefaultVar("PartyBuffs",		1);
	DefaultVar("PartyDebuffs",		1);
	DefaultVar("PartyCastableBuffs",	0);
	DefaultVar("PartyCurableDebuffs",	0);
	DefaultVar("Scale_PartyFrame",		0.8);
	DefaultVar("PartyDebuffsBelow",		0);
	DefaultVar("ShowPartyPets",		1);
	DefaultVar("Scale_PartyPets",		Perl_Config.Scale_PartyFrame);
	DefaultVar("ShowPartyPetName",		1);
	DefaultVar("ShowParty30YardSymbol",	1);
	DefaultVar("PartyBuffSize",		20);

	-- Raid
	DefaultVar("SortRaidByClass",		0);
	DefaultVar("ShowRaid",			1);
	DefaultVar("ShowGroup1",		1);
	DefaultVar("ShowGroup2",		1);
	DefaultVar("ShowGroup3",		1);
	DefaultVar("ShowGroup4",		1);
	DefaultVar("ShowGroup5",		1);
	DefaultVar("ShowGroup6",		1);
	DefaultVar("ShowGroup7",		1);
	DefaultVar("ShowGroup8",		1);
	DefaultVar("ShowGroup9",		0);
	DefaultVar("ShowGroup1",		1);
	DefaultVar("ShowRaidTitles",		1);
	DefaultVar("ShowRaidPercents",		1);
	DefaultVar("Scale_Raid",		0.8);
	DefaultVar("RaidVerticalSpacing",	42);
	DefaultVar("RaidPositions",		{});
	DefaultVar("RaidBuffs",			1);
	DefaultVar("RaidDebuffs",		0);
	DefaultVar("BuffsCastableCurable",	0);
	DefaultVar("RaidBuffsRight",		1);
	DefaultVar("RaidBuffsInside",		1);
	DefaultVar("RaidMotion",		1);

	-- Old vars. clear them out.
	Perl_Config.PerlPlayerPortrait3D	= nil;
	Perl_Config.ShowPartyDistance		= nil;
	Perl_Config.ShowTargetDistance		= nil;
	Perl_Config.UseTipBuddy			= nil;
	Perl_Config.ShowOldPlayerFrame		= nil;
	Perl_Config.TargetCounters		= nil;
	Perl_Config.TargetCountersSelf		= nil;
	Perl_Config.TargetCountersEnemy		= nil;
	Perl_Config.AssistsFrame		= nil;
	Perl_Config.TargettingFrame		= nil;
	Perl_Config.Scale_AssistsFrame		= nil;
	Perl_Config.AssistsFrame_Transparency	= nil;
end

-- Perl_ResetDefaults
function Perl_ResetDefaults()

	local rp = Perl_Config.RaidPositions

	Perl_Config = {}
	Perl_Defaults()

	if (Perl_Config_SavePerCharacter) then
		Perl_Config_Global[GetRealmName()][UnitName("player")] = Perl_Config
	end

	Perl_Config.RaidPositions = rp

	Perl_OptionActions()
end

-- Perl_Globals_OnLoad
function Perl_Globals_OnLoad()
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("RAID_ROSTER_UPDATE");
end

-- Perl_Globals_OnEvent
function Perl_Globals_OnEvent(event)
	if (event == "VARIABLES_LOADED") then
		-- Between sessions variable saving.
		this:UnregisterEvent(event);

		if (Perl_Config_SavePerCharacter) then
			if (not Perl_Config_Global) then
				Perl_Config_Global = {};
			end

			if (not Perl_Config_Global[GetRealmName()]) then
				Perl_Config_Global[GetRealmName()] = {};
			end

			if (not Perl_Config_Global[GetRealmName()][UnitName("player")]) then
				Perl_Config_Global[GetRealmName()][UnitName("player")] = {};

				if (Perl_Config and table.getn(Perl_Config) > 0) then
					Perl_Config_Global[GetRealmName()][UnitName("player")] = Perl_Config;
				end
			else
				Perl_Config = Perl_Config_Global[GetRealmName()][UnitName("player")];
			end

			if (not Perl_Config) then
				-- Create the global variable
				--Perl_Config = {};
				Perl_Config = Perl_Config_Global[GetRealmName()][UnitName("player")];
			end
		else
			Perl_Config_Global = nil;
			if (not Perl_Config) then
				-- Create the global variable
				Perl_Config = {};
			end
		end

		-- Tell DHUD to hide Blizzard default Player and Target frames
		if (DHUD_Config) then
			local bChanged = false;
			if (Perl_Player_Frame) then
				DHUD_Config["bplayer"] = 0;
				bChanged = true;
			end
			if (Perl_Target_Frame) then
				DHUD_Config["btarget"] = 0;
				bChanged = true;
			end

			if (DHUD_Config["bplayer"] == 1 or DHUD_Config["btarget"] == 1) then
				Perl_BlizzFramesDisable();
			end
		end


		Perl_BlizzFramesDisable();

		-- Variable checking only occurs for new install and version number change
		if ((not Perl_Config.ConfigVersion) or (Perl_Config.ConfigVersion ~= Perl_VersionNumber)) then
			Perl_Config.ConfigVersion = Perl_VersionNumber;	-- Set ConfigVersion to current

			Perl_Defaults();
		end

		Perl_Init();

		if (not string.find("Zek Hek Zeks Zekked Zekstuff Pooksie", UnitName("player")) or GetRealmName() ~= "Bloodhoof") then
			Perl_ShowMessage = function() end;
		end
	end
end

-- Perl_InitFadeFrame
function Perl_InitFadeFrame(argFrame)
	argFrame.Fading = 0;
	argFrame.FadeTime = 0;
	argFrame.IsShowing = function () return (argFrame:IsVisible() and argFrame.Fading == 0); end;
end

-- Perl_CancelFade
function Perl_CancelFade(argFrame)
	if (argFrame.Fading == 1) then
		argFrame.Fading = 0;
		argFrame:SetAlpha(Perl_Config.Transparency);
	end
end

-- Perl_StartFade(argFrame)
function Perl_StartFade(argFrame)
	argFrame:StopMovingOrSizing();

	if (Perl_Config.PerlFadeFrames == 1) then
		if (argFrame:IsVisible() and argFrame.Fading == 0) then
			argFrame.Fading = 1;
			argFrame.FadeTime = 0;
		end
	else
		argFrame:Hide();
	end
end

-- Perl_ProcessFade(argFrame)
function Perl_ProcessFade(argFrame)
	if (argFrame.Fading == 1) then
		argFrame.FadeTime = argFrame.FadeTime + arg1;

		if (argFrame.FadeTime >= 1) then
			argFrame:StopMovingOrSizing();
			argFrame:Hide();
			Perl_CancelFade(argFrame);
		else
			local newAlpha = Perl_Config.Transparency * (1 - argFrame.FadeTime);
			argFrame:SetAlpha(newAlpha);
		end
	end
end

-- Perl_Update_RaidIcon
function Perl_Update_RaidIcon(unit, frame)
	local index = GetRaidTargetIndex(unit);
	if ( index ) then
		SetRaidTargetIconTexture(frame, index);
		frame:Show();
	else
		frame:Hide();
	end
end
