function Perl_SetupFrame(argFrame)
	argFrame:SetBackdropBorderColor(Perl_Config.BorderColour.r, Perl_Config.BorderColour.g, Perl_Config.BorderColour.b, Perl_Config.BorderColour.a);	--, Perl_Config.Transparency);
	argFrame:SetBackdropColor(Perl_Config.BackColour.r, Perl_Config.BackColour.g, Perl_Config.BackColour.b, Perl_Config.BackColour.a);			--Perl_Config.Transparency);
end

function Perl_SetAllFrames()
	if (Perl_Player_Frame) then
		Perl_SetupFrame(Perl_Player_StatsFrame);
		Perl_SetupFrame(Perl_Player_PortraitFrame);
		Perl_SetupFrame(Perl_Player_NameFrame);
		Perl_SetupFrame(Perl_Player_LevelFrame);
		Perl_SetupFrame(Perl_Player_GroupFrame);
		Perl_Player_PVPRankIcon:SetAlpha(0.3);

		if (Perl_Player_TargettingFrame) then
        		Perl_SetupFrame(Perl_Player_TargettingFrame);
		end
	end

	if (Perl_Player_Pet_Frame) then
		Perl_SetupFrame(Perl_Player_Pet_StatsFrame);
		Perl_SetupFrame(Perl_Player_Pet_PortraitFrame);
		Perl_SetupFrame(Perl_Player_Pet_LevelFrame);
        	Perl_SetupFrame(Perl_Player_Pet_HappyFrame);
		Perl_SetupFrame(Perl_Player_Pet_NameFrame);
		Perl_SetupFrame(Perl_Player_Pet_BuffFrame);
	end

	if (Perl_Target_Frame) then
		Perl_SetupFrame(Perl_Target_StatsFrame);
		Perl_SetupFrame(Perl_Target_NameFrame);
		Perl_SetupFrame(Perl_Target_PortraitFrame);
		Perl_SetupFrame(Perl_Target_BuffFrame);
		Perl_SetupFrame(Perl_Target_LevelFrame);

		if (Perl_Target_AssistFrame) then
        		Perl_SetupFrame(Perl_Target_AssistFrame);
		end

		Perl_SetupFrame(Perl_Target_TypeFrame);
		Perl_SetupFrame(Perl_Target_BossFrame);
		Perl_SetupFrame(Perl_Target_CPFrame);

		Perl_Target_PVPRankIcon:SetAlpha(0.3);
	end

	if (Perl_TargetTarget) then
		Perl_SetupFrame(Perl_TargetTarget_StatsFrame);
		Perl_SetupFrame(Perl_TargetTarget_NameFrame);
		Perl_SetupFrame(Perl_TargetTarget_LevelFrame);
        	Perl_TargetTarget_NameFrame_PVPRankIcon:SetAlpha(0.3);
	end

	if (Perl_TargetTargetTarget) then
		Perl_SetupFrame(Perl_TargetTargetTarget_StatsFrame);
		Perl_SetupFrame(Perl_TargetTargetTarget_NameFrame);
		Perl_SetupFrame(Perl_TargetTargetTarget_LevelFrame);
        	Perl_TargetTargetTarget_NameFrame_PVPRankIcon:SetAlpha(0.3);
	end

	if (Perl_party1) then
		for num=1,4 do
			Perl_SetupFrame(getglobal("Perl_party"..num.."_StatsFrame"));
			Perl_SetupFrame(getglobal("Perl_party"..num.."_NameFrame"));
			Perl_SetupFrame(getglobal("Perl_party"..num.."_LevelFrame"));
			Perl_SetupFrame(getglobal("Perl_party"..num.."_BuffFrame"));
			Perl_SetupFrame(getglobal("Perl_party"..num.."_PortraitFrame"));

			Perl_SetupFrame(getglobal("Perl_party"..num.."_TargetFrame"));

			--if (UnitName("party"..num) and not UnitIsConnected("party"..num)) then
			--	getglobal("Perl_party"..num):SetAlpha(Perl_Config.Transparency / 2);
			--end

			if (Perl_Config.HighlightSelection == 1) then
				getglobal("Perl_party"..num.."_NameFrame_CastClickOverlay"):SetHighlightTexture("Interface\\Addons\\Perl\\images\\Perl_Highlight4x1", "ADD");
				getglobal("Perl_party"..num.."_TargetFrame_TargetCastClickOverlay"):SetHighlightTexture("Interface\\Addons\\Perl\\images\\Perl_Highlight4x1", "ADD");
			else
				getglobal("Perl_party"..num.."_NameFrame_CastClickOverlay"):SetHighlightTexture("");
				getglobal("Perl_party"..num.."_TargetFrame_TargetCastClickOverlay"):SetHighlightTexture("");
			end

			if (Perl_Config.ShowPartyValues == 1) then
				getglobal("Perl_party"..num.."_StatsFrame_HealthBarText"):Show();
				getglobal("Perl_party"..num.."_StatsFrame_ManaBarText"):Show();
			else
				getglobal("Perl_party"..num.."_StatsFrame_HealthBarText"):Hide();
				getglobal("Perl_party"..num.."_StatsFrame_ManaBarText"):Hide();
			end
		end
	end

	if (Perl_Party_Pet1) then
		for num=1,4 do
			Perl_SetupFrame(getglobal("Perl_Party_Pet"..num.."_StatsFrame"));
			Perl_SetupFrame(getglobal("Perl_Party_Pet"..num.."_NameFrame"));
			Perl_SetupFrame(getglobal("Perl_Party_Pet"..num.."_BuffFrame"));

			if (Perl_Config.HighlightSelection == 1) then
				getglobal("Perl_Party_Pet"..num.."_CastClickOverlay"):SetHighlightTexture("Interface\\Addons\\Perl\\images\\Perl_Highlight2x1", "ADD");
			else
				getglobal("Perl_Party_Pet"..num.."_CastClickOverlay"):SetHighlightTexture("");
			end
		end
	end

	if (Perl_Config.HighlightSelection == 1) then
		if (Perl_Player_Frame) then
			Perl_Player_CastClickOverlay:SetHighlightTexture("Interface\\Addons\\Perl\\images\\Perl_Highlight4x1", "ADD");
		end
		if (Perl_Player_TargettingFrame) then
			Perl_Player_TargettingFrame:SetHighlightTexture("Interface\\Addons\\Perl\\images\\Perl_Highlight2x1", "ADD");
		end
		if (Perl_Player_Pet_Frame) then
			Perl_Player_Pet_CastClickOverlay:SetHighlightTexture("Interface\\Addons\\Perl\\images\\Perl_Highlight2x1", "ADD");
		end
		if (Perl_Target_Frame) then
			Perl_Target_CastClickOverlay:SetHighlightTexture("Interface\\Addons\\Perl\\images\\Perl_Highlight4x1", "ADD");
		end
		if (Perl_Target_AssistFrame) then
			Perl_Target_AssistFrame:SetHighlightTexture("Interface\\Addons\\Perl\\images\\Perl_Highlight2x1", "ADD");
		end
		if (Perl_TargetTarget) then
			Perl_TargetTarget_CastClickOverlay:SetHighlightTexture("Interface\\Addons\\Perl\\images\\Perl_Highlight4x1", "ADD");
		end
		if (Perl_TargetTargetTarget) then
			Perl_TargetTargetTarget_CastClickOverlay:SetHighlightTexture("Interface\\Addons\\Perl\\images\\Perl_Highlight4x1", "ADD");
		end
	else
		if (Perl_Player_Frame) then
			Perl_Player_CastClickOverlay:SetHighlightTexture("");
		end
		if (Perl_Player_TargettingFrame) then
			Perl_Player_TargettingFrame:SetHighlightTexture("");
		end
		if (Perl_Player_Pet_Frame) then
			Perl_Player_Pet_CastClickOverlay:SetHighlightTexture("");
		end
		if (Perl_Target_Frame) then
			Perl_Target_CastClickOverlay:SetHighlightTexture("");
		end
		if (Perl_Target_AssistFrame) then
			Perl_Target_AssistFrame:SetHighlightTexture("");
		end
		if (Perl_TargetTarget) then
			Perl_TargetTarget_CastClickOverlay:SetHighlightTexture("");
		end
		if (Perl_TargetTargetTarget) then
			Perl_TargetTargetTarget_CastClickOverlay:SetHighlightTexture("");
		end
	end

	if (Perl_TargetTarget) then
		for num=1,10 do
			local f = getglobal("Perl_TargetTarget_History"..num);
			if (f) then
				Perl_SetupFrame(f);
			end
		end
	end

	if (Perl_SetupRaidFrames) then
		Perl_SetupRaidFrames();
	end
end

function Perl_Init()
	Perl_HookBuffFrame();

	-- Check for eCastbar and disable old frame if used.
	if (eCastingBar_Saved and eCastingBar_Player and eCastingBar_Saved[eCastingBar_Player].Enabled == 1) then
		Perl_Config.OldCastBar = 0;
	elseif (BCastBar and BCastingBar and BCastBarDragButton) then
		Perl_Config.OldCastBar = 0;
	end

	if (Perl_Player_Frame) then
		Perl_Player_Frame:Show();
	end

	Perl_OptionActions();
	Perl_SlashOnLoad();

	local name, title, notes, enabled, loadable, reason, security = GetAddOnInfo("PerlButton");
	if (name and enabled) then
		Perl_Notice("Disable 'PerlButton' addon. It is not compatible or needed with X-Perl");
		-- PerlButton was made for Nymbia's Perl UnitFrames. We have our own minimap button
	end

	local name, title, notes, enabled, loadable, reason, security = GetAddOnInfo("CT_PartyBuffs");
	if (name and enabled) then
		Perl_Notice("Disable 'CT_PartyBuffs' addon. It is not compatible with X-Perl, and creates display issues.");
	end
	if (CT_PartyBuffFrame1) then
		CT_PartyBuffFrame1:Hide();
		CT_PartyBuffFrame2:Hide();
		CT_PartyBuffFrame3:Hide();
		CT_PartyBuffFrame4:Hide();
		CT_PetBuffFrame:Hide();
	end

	if (EarthFeature_AddButton) then
		local button = {}
		button.name = Perl_ProductName;
		button.icon = Perl_ModMenuIcon;
		button.subtext = "By "..Perl_Author;
		button.tooltip = Perl_LongDescription;
		button.callback = Perl_Toggle;
		EarthFeature_AddButton (button);
	end

	if(CT_RegisterMod) then
		CT_RegisterMod(Perl_Version, "By "..Perl_Author, 4, Perl_ModMenuIcon, Perl_LongDescription, "switch", "", Perl_Toggle);
	end

	if (myAddOnsFrame) then
                myAddOnsList.Perl_Description = {
                        name			= Perl_Description,
                        description		= "Modifies the default party and target frames.",
                        version			= Perl_VersionNumber,
                        category		= MYADDONS_CATEGORY_OTHERS,
                        frame			= "Perl_Globals",
                        optionsframe		= "Perl_FrameOptions_Frame"
                        };
	end
end

-- Buff Frame Hooks
local Perl_Hook_BuffButtonTemplate_OnEnter = nil;
local Perl_Hook_BuffButtonTemplate_OnUpdate = nil;
local function Perl_BuffButtonTemplate_OnEnter()
	Perl_Hook_BuffButtonTemplate_OnEnter();
	Perl_ToolTip_AddBuffDuration("player");
end

local function Perl_BuffButtonTemplate_OnUpdate()
	Perl_Hook_BuffButtonTemplate_OnUpdate();

	if (this.untilCancelled ~= 1) then
		if (BuffFrameUpdateTime <= 0) then
			Perl_ToolTip_AddBuffDuration("player");
		end
	end
end

function Perl_HookBuffFrame()
	for i = 0,15 do
		local button = getglobal("BuffButton"..i);
		if (button:GetScript("OnEnter") ~= Perl_BuffButtonTemplate_OnEnter) then
			if (Perl_Hook_BuffButtonTemplate_OnEnter == nil) then
				Perl_Hook_BuffButtonTemplate_OnEnter = button:GetScript("OnEnter");
			end
			button:SetScript("OnEnter", Perl_BuffButtonTemplate_OnEnter);
		end
		if (button:GetScript("OnUpdate") ~= Perl_BuffButtonTemplate_OnUpdate) then
			if (Perl_Hook_BuffButtonTemplate_OnUpdate == nil) then
				Perl_Hook_BuffButtonTemplate_OnUpdate = button:GetScript("OnUpdate");
			end
			button:SetScript("OnUpdate", Perl_BuffButtonTemplate_OnUpdate);
		end
	end
end
