local Perl_Party_Events = {}
local thisid = nil;

----------------------
-- Loading Function --
----------------------
local function NewShowPartyFrame()
	return;
end

function Perl_Party_OnLoad()
	--Events
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("PLAYER_LEAVING_WORLD");

	getglobal("Perl_party"..this:GetID().."_DropDown"):SetID(this:GetID());
	table.insert(UnitPopupFrames,"Perl_party"..this:GetID().."_DropDown");

	HidePartyFrame();
	ShowPartyFrame = NewShowPartyFrame;

	this.PlayerFlash = 0;
	this.time = 0;
	this.feigning = 0;
	this.partyid = "party"..this:GetID();

	Perl_InitFadeFrame(this);
end

local function Perl_Party_RegisterSome()
	this:RegisterEvent("PARTY_MEMBERS_CHANGED");
	this:RegisterEvent("PARTY_LEADER_CHANGED");
	this:RegisterEvent("PARTY_LOOT_METHOD_CHANGED");
	this:RegisterEvent("UNIT_FACTION");
	this:RegisterEvent("UNIT_DYNAMIC_FLAGS");
	this:RegisterEvent("UNIT_FLAGS");
	this:RegisterEvent("UNIT_AURA");
	this:RegisterEvent("PARTY_MEMBER_ENABLE");
	this:RegisterEvent("PARTY_MEMBER_DISABLE");
	this:RegisterEvent("UNIT_MODEL_CHANGED");
	Perl_RegisterBasics();
end
local function Perl_Party_UnregisterSome()
	this:UnregisterEvent("PARTY_MEMBERS_CHANGED");
	this:UnregisterEvent("PARTY_LEADER_CHANGED");
	this:UnregisterEvent("PARTY_LOOT_METHOD_CHANGED");
	this:UnregisterEvent("UNIT_FACTION");
	this:UnregisterEvent("UNIT_DYNAMIC_FLAGS");
	this:UnregisterEvent("UNIT_FLAGS");
	this:UnregisterEvent("UNIT_AURA");
	this:UnregisterEvent("PARTY_MEMBER_ENABLE");
	this:UnregisterEvent("PARTY_MEMBER_DISABLE");
	this:UnregisterEvent("UNIT_MODEL_CHANGED");
	Perl_UnregisterBasics();
end

local function ShowHideValues(prefix)
	if (Perl_Config.ShowPartyValues == 1) then
        	getglobal(prefix.."_StatsFrame_HealthBarText"):Show();
        	getglobal(prefix.."_StatsFrame_ManaBarText"):Show();
	else
        	getglobal(prefix.."_StatsFrame_HealthBarText"):Hide();
        	getglobal(prefix.."_StatsFrame_ManaBarText"):Hide();
	end
end

local function Perl_Party_ShowPercentages(thisFrame)
	if (Perl_Config.ShowPartyPercent==1) then
		thisid = thisFrame:GetName();
		getglobal(thisid.."_StatsFrame"):SetWidth(136);
	end
	ShowHideValues(thisid);
end

local function Perl_Party_HidePercentages(thisFrame, argReason)
	thisid = thisFrame:GetName();
	getglobal(thisid.."_StatsFrame"):SetWidth(106);

	if (argReason) then
                getglobal(thisid.."_StatsFrame_HealthBarText"):SetText(argReason);
               	getglobal(thisid.."_StatsFrame_HealthBarText"):Show();
                getglobal(thisid.."_StatsFrame_ManaBarText"):Hide();
	else
		ShowHideValues(thisid);
	end

        getglobal(thisid.."_StatsFrame_HealthBarPercent"):Hide();
        getglobal(thisid.."_StatsFrame_ManaBarPercent"):Hide();
end

local function Perl_Party_UpdateHealth(id)
	local thisFrame;
	if (id == nil) then
		thisFrame = this;
	else
		thisFrame = getglobal("Perl_"..id);
	end

	if (thisFrame and thisFrame.partyid) then
		local numID = thisFrame:GetID();
		--partyid = ("party"..numID);
		thisid = thisFrame:GetName();
		local Partyhealth = UnitHealth(thisFrame.partyid);
		local Partyhealthmax = UnitHealthMax(thisFrame.partyid);
		local frameID = thisid.."_StatsFrame_"
		local percVis = getglobal(frameID.."HealthBarPercent"):IsShown();
		if ((thisFrame.feigning == 1) and (Partyhealth>1)) then
			thisFrame.feigning = 0;
		end
		if  (thisFrame.feigning == 1) then
	                getglobal(frameID.."HealthBar"):SetMinMaxValues(0, 1);
	                getglobal(frameID.."HealthBar"):SetValue(0);
	                --getglobal(frameID.."HealthBar"):SetStatusBarColor(Perl_Config.HealthBarColour.r,Perl_Config.HealthBarColour.g,Perl_Config.HealthBarColour.b);
		else
	                getglobal(frameID.."HealthBar"):SetMinMaxValues(0, Partyhealthmax);
	                getglobal(frameID.."HealthBar"):SetValue(Partyhealth);
		end
	        Perl_SetSmoothBarColor(getglobal(frameID.."HealthBar"),getglobal(frameID.."HealthBarBG"), 0.25);

		phealthPct = (Partyhealth * 100.0) / Partyhealthmax
		phealthPct = string.format("%3.0f", phealthPct);
	        getglobal(frameID.."HealthBarPercent"):SetText(string.format("%d",(100*(Partyhealth / Partyhealthmax))+0.5).."%");
	        getglobal(frameID.."HealthBarPercent"):Show();

		Perl_Party_ShowPercentages(thisFrame);

		if (Perl_Config.HealerMode == 1) then
	        	getglobal(frameID.."HealthBarText"):SetText(-(Partyhealthmax - Partyhealth));
		else
	        	getglobal(frameID.."HealthBarText"):SetText(Partyhealth.."/"..Partyhealthmax);
		end

		local petFrame = getglobal("Perl_Party_Pet"..numID);
		if (not UnitIsConnected(thisFrame.partyid)) then
			Perl_Party_HidePercentages(thisFrame, PERL_LOC_OFFLINE);
			thisFrame:SetAlpha(Perl_Config.Transparency/2);
			if (petFrame) then
				petFrame:SetAlpha(Perl_Config.Transparency/2);
			end
		else
			thisFrame:SetAlpha(Perl_Config.Transparency);
			if (petFrame) then
				petFrame:SetAlpha(Perl_Config.Transparency);
			end

			if (thisFrame.feigning == 1) then
				Perl_Party_HidePercentages(thisFrame, PERL_LOC_FEIGNDEATH);

			elseif (UnitIsDead(thisFrame.partyid)) then
				Perl_Party_HidePercentages(thisFrame, PERL_LOC_DEAD);

			elseif (UnitIsGhost(thisFrame.partyid)) then
				Perl_Party_HidePercentages(thisFrame, PERL_LOC_GHOST);

			elseif ((Partyhealth==1) and (Partyhealthmax==1)) then
				Perl_Party_HidePercentages(thisFrame, PERL_LOC_UPDATING);
			end
		end

		if (Perl_Config.ShowPartyPercent == 0) then
			Perl_Party_HidePercentages(thisFrame);
		end

		if (percVis ~= getglobal(frameID.."HealthBarPercent"):IsShown()) then
			Perl_StatsFrame_Setup(getglobal(thisid.."_StatsFrame"));
		end
	end
end

--------------------
-- Buff Functions --
--------------------
local function Perl_Party_SetDebuffLoc(thisFrame)
	local debuff1 = getglobal(thisid.."_BuffFrame_DeBuff1");
        debuff1:ClearAllPoints();

	if (Perl_Config.PartyDebuffsBelow==0) then
		local petFrame = getglobal("Perl_Party_Pet"..thisFrame:GetID());
		if (petFrame and petFrame:IsVisible()) then
                        debuff1:SetPoint("LEFT", "Perl_Party_Pet"..thisFrame:GetID().."_StatsFrame", "RIGHT", 0, 0);
		else
                        debuff1:SetPoint("LEFT", "Perl_party"..thisFrame:GetID().."_StatsFrame", "RIGHT", 0, 0);
		end
	else
                debuff1:SetPoint("TOPLEFT", ("Perl_party"..thisFrame:GetID().."_BuffFrame_Buff1"), "BOTTOMLEFT", 0, -2);
	end
end

local function Perl_Party_Buff_UpdateAll(id)
	local thisFrame;
	if (id == nil) then
		thisFrame = this;
	else
		thisFrame = getglobal("Perl_"..id);
	end

	if (thisFrame and thisFrame.partyid) then
		if (Perl_Config.PartyBuffs == 0 and Perl_Config.PartyDebuffs == 0) then
			getglobal(thisFrame:GetName().."_BuffFrame"):Hide();
		else
			getglobal(thisFrame:GetName().."_BuffFrame"):Show();

			thisid = thisFrame:GetName();
			if (UnitName(thisFrame.partyid)) then
				local needUpdateHealth = false;
				Perl_Party_SetDebuffLoc(thisFrame);

				for buffnum=1,10 do
	        	                local button = getglobal(thisid.."_BuffFrame_Buff"..buffnum);

					if (Perl_Config.PartyBuffs == 1) then
						local icon = getglobal(button:GetName().."Icon");
						local buff, count = UnitBuff(thisFrame.partyid, buffnum, Perl_Config.PartyCastableBuffs);
						if (buff) then
							icon:SetTexture(buff);
							if (strfind(strlower(buff), "feigndeath")) then
								if (thisFrame.feigning == 0) then
									thisFrame.feigning = 1;
									needUpdateHealth = true;
								end
							end
							local buffCount = getglobal(thisid.."_BuffFrame_Buff"..buffnum.."Count");
							if (count > 1) then
								buffCount:SetText(count);
								buffCount:Show();
							else
								buffCount:Hide();
							end
							button:Show();
						else
							button:Hide();
						end
					else
						button:Hide();
					end
				end

				for buffnum=1,8 do
	        	                local button = getglobal(thisid.."_BuffFrame_DeBuff"..(buffnum));

					if (Perl_Config.PartyDebuffs == 1) then
						local buff, count, debuffType = UnitDebuff(thisFrame.partyid, buffnum, Perl_Config.PartyCurableDebuffs);
						if (buff) then
							local icon = getglobal(button:GetName().."Icon");
							icon:SetTexture(buff);

							local buffCount = getglobal(thisid.."_BuffFrame_DeBuff"..buffnum.."Count");
							if (count > 1) then
								buffCount:SetText(count);
								buffCount:Show();
							else
								buffCount:Hide();
							end

							local borderColor = DebuffTypeColor[(debuffType or "none")];
							local buffBorder = getglobal(thisid.."_BuffFrame_DeBuff"..buffnum.."Border");
							buffBorder:SetVertexColor(borderColor.r, borderColor.g, borderColor.b);

							button:Show();
						else
							button:Hide();
						end
					else
						button:Hide();
					end
				end

				if (needUpdateHealth) then
					Perl_Party_UpdateHealth();
				end
			end
		end
	end

	Perl_CheckDebuffs(thisFrame.partyid, {getglobal(thisFrame:GetName().."_NameFrame"),getglobal(thisFrame:GetName().."_LevelFrame"),getglobal(thisFrame:GetName().."_PortraitFrame"),getglobal(thisFrame:GetName().."_StatsFrame")});
end

function Perl_Party_SetBuffTooltip ()
	local partyid = "party"..this:GetParent():GetParent():GetID();
	GameTooltip:SetOwner(this,"ANCHOR_BOTTOMRIGHT",30,0);
	GameTooltip:SetUnitBuff(partyid, this:GetID(), Perl_Config.PartyCastableBuffs);
	Perl_ToolTip_AddBuffDuration(partyid);
end

function Perl_Party_SetDeBuffTooltip ()
	local partyid = "party"..this:GetParent():GetParent():GetID();
	GameTooltip:SetOwner(this,"ANCHOR_BOTTOMRIGHT",30,0);
	GameTooltip:SetUnitDebuff(partyid, this:GetID(), Perl_Config.PartyCurableDebuffs);
end

-------------------------
-- The Update Function --
-------------------------
local function Perl_Party_CombatFlash(elapsed, argNew, argGreen)
	if (Perl_CombatFlashSet (elapsed, this, argNew, argGreen)) then
		Perl_CombatFlashSetFrames(getglobal("Perl_"..this.partyid.."_NameFrame"), this.PlayerFlash, this.PlayerFlashGreen);
		Perl_CombatFlashSetFrames(getglobal("Perl_"..this.partyid.."_LevelFrame"), this.PlayerFlash, this.PlayerFlashGreen);
		Perl_CombatFlashSetFrames(getglobal("Perl_"..this.partyid.."_StatsFrame"), this.PlayerFlash, this.PlayerFlashGreen);
		Perl_CombatFlashSetFrames(getglobal("Perl_"..this.partyid.."_PortraitFrame"), this.PlayerFlash, this.PlayerFlashGreen);
	end
end

function Perl_Party_UpdatePortrait(id)
	if (Perl_Config.ShowPartyPortrait == 1) then
		local thisFrame;
		if (id == nil) then
			thisFrame = this;
		else
			thisFrame = getglobal("Perl_"..id);
		end

		if (thisFrame and thisFrame.partyid) then
			local framePortrait = getglobal(thisFrame:GetName().."_PortraitFrame_Portrait");
			local framePortrait3D = getglobal(thisFrame:GetName().."_PortraitFrame_Portrait3D");

			if (Perl_Config.ShowPlayerPortrait3D == 1 and UnitIsVisible(thisFrame.partyid)) then
				framePortrait:Hide();
				framePortrait3D:Show();
				PerlSetPortrait3D(framePortrait3D, thisFrame.partyid);
			else
				framePortrait:Show();
				framePortrait3D:Hide();
				SetPortraitTexture(framePortrait, thisFrame.partyid);
			end
		end
	end
end

local function Perl_Party_UpdateName(id)
	local thisFrame;
	if (id == nil) then
		thisFrame = this;
	else
		thisFrame = getglobal("Perl_"..id);
	end

	if (thisFrame and thisFrame.partyid) then
		thisid = thisFrame:GetName();
		local Partyname = UnitName(thisFrame.partyid);
		if (Partyname) then
			local frame = getglobal(thisid.."_NameFrame_NameBarText");

			if (strlen(Partyname) > 40) then
				Partyname = strsub(Partyname, 1, 39).."...";
			end
        	        if (Perl_Config.ShowPartyNames==1) then
				getglobal(thisid.."_NameFrame"):Show();
			end
        	        frame:SetText(Partyname);

			Perl_ColourFriendlyUnit(frame, thisFrame.partyid);
		end
	end
end

local function Perl_Party_UpdateLeader(idf)
	local thisFrame;
	if (idf == nil) then
		thisFrame = this;
	else
		thisFrame = getglobal("Perl_"..idf);
	end

	if (thisFrame and thisFrame.partyid) then
		--partyid = ("party"..this:GetID());
		thisid = thisFrame:GetName();
		local id = thisFrame:GetID();
	        local icon = getglobal(thisid.."_NameFrame_LeaderIcon");
		if (GetPartyLeaderIndex() == id ) then
			icon:Show();
		else
			icon:Hide();
		end
	        icon = getglobal(thisid.."_NameFrame_MasterIcon");
		local lootMethod;
		local lootMaster;
		lootMethod, lootMaster = GetLootMethod();
		if ( id == lootMaster ) then
			icon:Show();
		else
			icon:Hide();
		end
	end
end

local function Perl_Party_Update_Control(id)
	local thisFrame;
	if (id == nil) then
		thisFrame = this;
	else
		thisFrame = getglobal("Perl_"..id);
	end

	if (thisFrame and thisFrame.partyid) then
	        if (UnitIsVisible(thisFrame.partyid) and UnitIsCharmed(thisFrame.partyid)) then
			--Perl_Target_Warning:SetTexture("Interface\Minimap\Ping\ping6");
			--Perl_Target_Warning:SetBlendMode("ADD");
			getglobal(thisFrame:GetName().."_NameFrame_Warning"):Show();
		else
			getglobal(thisFrame:GetName().."_NameFrame_Warning"):Hide();
		end
	end
end

local function Perl_Party_UpdatePVP(id)
	local thisFrame;
	if (id == nil) then
		thisFrame = this;
	else
		thisFrame = getglobal("Perl_"..id);
	end

	if (thisFrame and thisFrame.partyid) then
		local f = getglobal(thisFrame:GetName().."_NameFrame_PVPStatus");
		if (UnitIsPVP(thisFrame.partyid)) then
			f:SetTexture("Interface\\TargetingFrame\\UI-PVP-"..(UnitFactionGroup(thisFrame.partyid) or "FFA"));
	                f:Show();
		else
	                f:Hide();
		end
	end
end

function Perl_Party_UpdateCombat(id)
	local thisFrame;
	if (id == nil) then
		thisFrame = this;
	else
		thisFrame = getglobal("Perl_"..id);
	end

	if (thisFrame and thisFrame.partyid) then
	        Perl_Party_UpdateCombat1(thisFrame.partyid, thisFrame:GetName());
		Perl_Party_Update_Control();
	end
end

function Perl_Party_UpdateCombat1(argID,argName)
	local frame = getglobal(argName.."_NameFrame_ActivityStatus");
	if (not (frame == nil)) then
	        if (UnitName(argID) and UnitAffectingCombat(argID)) then
	                frame:Show();
		else
	                frame:Hide();
		end
	end
end

local function Perl_Party_UpdateLevel(id)
	local thisFrame;
	if (id == nil) then
		thisFrame = this;
	else
		thisFrame = getglobal("Perl_"..id);
	end

	if (thisFrame and thisFrame.partyid) then
		--partyid = ("party"..this:GetID());
		thisid = thisFrame:GetName();
		local Partylevel = UnitLevel(thisFrame.partyid);
		local color = GetDifficultyColor(Partylevel);
	        getglobal(thisid.."_LevelFrame_LevelBarText"):SetTextColor(color.r,color.g,color.b);
	        getglobal(thisid.."_LevelFrame_LevelBarText"):SetText(Partylevel);
	end
end

local function Perl_Party_UpdateClass(id)
	local thisFrame;
	if (id == nil) then
		thisFrame = this;
	else
		thisFrame = getglobal("Perl_"..id);
	end

	if (thisFrame and thisFrame.partyid) then
		--partyid = ("party"..this:GetID());
		thisid = thisFrame:GetName();
		if (UnitIsPlayer(thisFrame.partyid)) then
			local _, PlayerClass = UnitClass(thisFrame.partyid);
			local r, l, t, b = Perl_ClassPos(PlayerClass);
			getglobal(thisid.."_LevelFrame_ClassTexture"):SetTexCoord(r, l, t, b);
		end

		if (Perl_Config.ShowPartyClassIcon==1) then
	                getglobal(thisid.."_LevelFrame_ClassTexture"):Show();
		else
	                getglobal(thisid.."_LevelFrame_ClassTexture"):Hide();
		end
	end
end

local function Perl_Party_UpdateManaType(id)
	local thisFrame;
	if (id == nil) then
		thisFrame = this;
	else
		thisFrame = getglobal("Perl_"..id);
	end

	if (thisFrame and thisFrame.partyid) then
		local frameName = thisFrame:GetName().."_StatsFrame_ManaBar";
		Perl_SetManaBarType(thisFrame.partyid, getglobal(frameName), getglobal(frameName.."BG"));
	end
end

local function Perl_Party_UpdateMana(id)
	local thisFrame;
	if (id == nil) then
		thisFrame = this;
	else
		thisFrame = getglobal("Perl_"..id);
	end

	if (thisFrame and thisFrame.partyid) then
		--partyid = ("party"..this:GetID());
		thisid = thisFrame:GetName();
		local Partymana = UnitMana(thisFrame.partyid);
		local Partymanamax = UnitManaMax(thisFrame.partyid);
		local frameManaBar = getglobal(thisid.."_StatsFrame_ManaBar");
		local frameManaBarText = getglobal(thisid.."_StatsFrame_ManaBarText");
		local frameManaBarPercent = getglobal(thisid.."_StatsFrame_ManaBarPercent");
		local frameHealthBarPercent = getglobal(thisid.."_StatsFrame_HealthBarPercent");

		if (Partymanamax == 1 and Partymana > Partymanamax) then
			Partymanamax = Partymana;
		end

	        frameManaBar:SetMinMaxValues(0, Partymanamax);
	        frameManaBar:SetValue(Partymana);
		pmanaPct = (Partymana * 100.0) / Partymanamax
		pmanaPct =  string.format("%3.0f", pmanaPct);
	        if (frameHealthBarPercent:IsVisible()) then
			frameManaBarPercent:Show();
		end
		if (UnitPowerType(thisFrame.partyid)>=1) then
	                frameManaBarPercent:SetText(Partymana);
		else
	                frameManaBarPercent:SetText(string.format("%d",(100*(Partymana / Partymanamax))+0.5).."%");
		end

		if (Perl_Config.ShowPartyValues == 1) then
	        	frameManaBarText:Show();
		else
	        	frameManaBarText:Hide();
		end

	        frameManaBarText:SetText(Partymana.."/"..Partymanamax);
		if (Perl_Config.ShowPartyPercent==0) then
	                frameManaBarPercent:Hide();
	                frameHealthBarPercent:Hide();
	                getglobal(thisid.."_StatsFrame"):SetWidth(106);
		end
		local petFrame = getglobal("Perl_Party_Pet"..thisFrame:GetID());
		if (UnitIsConnected(thisFrame.partyid)) then
			thisFrame:SetAlpha(Perl_Config.Transparency);
			if (petFrame) then
				petFrame:SetAlpha(Perl_Config.Transparency);
			end
		else
			thisFrame:SetAlpha(Perl_Config.Transparency/2);
			if (petFrame) then
		      		petFrame:SetAlpha(Perl_Config.Transparency/2);
			end
	                getglobal(thisid.."_StatsFrame_HealthBarText"):SetText("Offine");
		end
	end
end

local function Perl_Party_UpdateRange(id)
	local thisFrame;
	if (id == nil) then
		thisFrame = this;
	else
		thisFrame = getglobal("Perl_"..id);
	end

	if (thisFrame and thisFrame.partyid) then
		local f = getglobal(thisFrame:GetName().."_NameFrame_RangeStatus");

		if (Perl_Config.ShowParty30YardSymbol == 0 or CheckInteractDistance(thisFrame.partyid, 4) or not UnitIsConnected(thisFrame.partyid)) then
			f:Hide();
		else
			f:Show();
			f:SetAlpha(1);
		end
	end
end

function Perl_Party_OnUpdate(elapsed)
        if (CastPartyConfig and (Perl_Config.CastPartyShow==0)) then
		if (CastPartyMainFrame) then
			CastPartyMainFrame:Hide();
		end
		if (CastPartyFrame0 and CastPartyFrame1 and CastPartyFrame2) then
			CastPartyFrame0:Hide();
			CastPartyFrame1:Hide();
			CastPartyFrame2:Hide();
		end
	end

	if elapsed then
		thisid = this:GetName();

		Perl_Party_CombatFlash(elapsed, false);

		this.time = elapsed + this.time;
		if this.time >= 0.2 then
			Perl_Party_UpdateRange();
			Perl_Party_UpdateTarget();
			this.time=0;
		end
	end

	Perl_ProcessFade(this);
end

local function Perl_Party_StartFade(thisFrame)
	local framePet = getglobal("Perl_Party_Pet"..thisFrame:GetID());
	if (framePet and framePet:IsVisible()) then
		Perl_StartFade(framePet);
	end
	Perl_StartFade(thisFrame);

	if (UnitName(thisFrame.partyid) and not UnitIsConnected(thisFrame.partyid)) then
		thisFrame.FadeTime = 0.5;
		if (framePet and framePet:IsVisible()) then
			framePet.FadeTime = 0.5;
		end
	end
end

function Perl_Party_UpdateDisplayAll()
	for i = 1,4 do
		Perl_Party_UpdateDisplay("party"..i);
	end
end

function Perl_Party_UpdateDisplay(id)
	local thisFrame;
	if (id == nil) then
		thisFrame = this;
	else
		thisFrame = getglobal("Perl_"..id);
	end

	if (thisFrame and thisFrame.partyid) then
		--partyid = ("party"..this:GetID());
		thisid = thisFrame:GetName();
		if (UnitName(thisFrame.partyid)) then
			Perl_CancelFade(thisFrame);

			Perl_Party_UpdateName(id);
			Perl_Party_UpdateLeader(id);
			Perl_Party_UpdateClass(id);
			Perl_Party_UpdateManaType(id);
			Perl_Party_UpdateHealth(id);
			Perl_Party_UpdateMana(id);
			Perl_Party_UpdateLevel(id);
			Perl_Party_Update_Control(id);
        	        Perl_Party_UpdateCombat(id);
			Perl_Party_UpdatePVP(id);
			Perl_Party_UpdatePortrait(id);
			Perl_Party_Buff_UpdateAll(id);

			if (UnitName("raid1")) then
				if (Perl_Config.ShowPartyRaid==1) then
					thisFrame:Show();
				elseif (Perl_Config.ShowPartyRaid == 0) then
					Perl_Party_StartFade(thisFrame);
				end
			else
				thisFrame:Show();
			end

		else
			Perl_Party_StartFade(thisFrame);
		end
	end
end

--------------------
-- Click Handlers --
--------------------
-- Non local by request (GenesisClicks/Elsewhere)
function Perl_Party_FindID(object)
	local _, _, num = string.find(object:GetName(), "(%d+)");
	return tonumber(num);
end

local function Perl_PartyDropDown_Initialize()
	local dropdown;
	if ( UIDROPDOWNMENU_OPEN_MENU ) then
		dropdown = getglobal(UIDROPDOWNMENU_OPEN_MENU);
	else
		dropdown = this;
	end
	UnitPopup_ShowMenu(dropdown, "PARTY", "party"..dropdown:GetParent():GetID());
end

function Perl_PartyDropDown_OnLoad()
	UIDropDownMenu_Initialize(this, Perl_PartyDropDown_Initialize, "MENU");
end

function Perl_Party_OnClick(button,argTarget)
	local id=Perl_Party_FindID(this);
	this:SetID(id);
	local unit = "party"..id;

	if (argTarget == 1) then
		unit = unit.."target";
	end

	if (Perl_OnClick_Handler(button, unit)) then
		return;
	end

	if (button == "RightButton") then
		if (argTarget == 0) then
			ToggleDropDownMenu(1, nil, getglobal("Perl_party"..id.."_DropDown"), this:GetName(), 0, 0);
		end
	end
end

function Perl_Party_PlayerTip(argTarget)
        Perl_Options_SelectFrame("party");

	local id=Perl_Party_FindID(this);
	--GameTooltip_SetDefaultAnchor(GameTooltip, this);
	--GameTooltip:SetUnit("party"..id);

	local unitid = "party"..id;
	if (argTarget) then
		unitid = unitid.."target";
	end

	Perl_PlayerTip(unitid);
end

function Perl_Party_UpdateTarget(id)
	local thisFrame;
	if (id == nil) then
		thisFrame = this;
	else
		thisFrame = getglobal("Perl_"..id);
	end

	if (thisFrame and thisFrame.partyid) then
		local frame = getglobal("Perl_"..thisFrame.partyid.."_TargetFrame");
		local petFrame = getglobal("Perl_Party_Pet"..thisFrame:GetID());

		if (frame == nil) then
			return
		end
		if (frame.Fading == 1) then
			return;
		end

		if (Perl_Config.ShowPartyTarget == 1) then
			local frameText = getglobal("Perl_"..thisFrame.partyid.."_TargetFrame_Target");
			if (UnitIsConnected(thisFrame.partyid) and UnitName(thisFrame.partyid) and UnitIsVisible(thisFrame.partyid)) then
				local unit = thisFrame.partyid.."target";
				local targetname = UnitName(unit);

				if (targetname and targetname ~= UNKNOWNOBJECT) then
				-- if (UnitExists (unit)) then - Changed as a test, as u can often pick up unit name, and unit class, but not health etc.
					--local targetname = UnitName(unit);
					frameText:SetText(targetname);
					local width = frameText:GetStringWidth();

					if (width < 68) then
						frame:SetWidth(68);
					elseif (width > 112) then
						frame:SetWidth(120);

						local remCount = 1;
						while ((frameText:GetStringWidth() >= 112) and (string.len(targetname) > remCount)) do
							targetname = string.sub(targetname, 1, string.len(targetname) - remCount).."..";
							remCount = 3;
							frameText:SetText(targetname);
						end
					else
						frame:SetWidth(width + 8);
					end

					Perl_SetUnitNameColor (unit, frameText);
					frame:Show();

					local frameAct = getglobal("Perl_"..thisFrame.partyid.."_TargetFrame_TargetActivityStatus");
				        if (UnitAffectingCombat(unit)) then
				                frameAct:SetTexCoord(0.5, 1.0, 0.0, 0.5);
				                frameAct:Show();
					else
				                frameAct:Hide();
					end

					local framePVP = getglobal("Perl_"..thisFrame.partyid.."_TargetFrame_TargetPVPStatus");
					if (UnitIsPVP(unit)) then
						framePVP:SetTexture("Interface\\TargetingFrame\\UI-PVP-"..(UnitFactionGroup(unit) or "FFA"));
						framePVP:Show();
					else
						framePVP:Hide();
					end
				else
					frame:Hide();
				end
			else
				frame:Hide();
			end
		else
			frame:Hide();
		end

		if (petFrame) then
			petFrame:ClearAllPoints();
			if (frame:IsShown() and Perl_Config.ShowPartyPetName == 1) then
				petFrame:SetPoint("TOPLEFT", frame, "TOPRIGHT", -2, 2);
			else
				if (Perl_Config.ShowPartyPetName == 1) then
					petFrame:SetPoint("TOPLEFT", frame:GetParent():GetName().."_StatsFrame", "TOPRIGHT", -2, 21);
				else
					petFrame:SetPoint("TOPLEFT", frame:GetParent():GetName().."_StatsFrame", "TOPRIGHT", -2, 0);
				end
			end
		end
	end
end

-------------------
-- Event Handler --
-------------------
function Perl_Party_OnEvent()
	local func = Perl_Party_Events[event];
	if (func) then
		func();
	else
Perl_ShowMessage("EXTRA EVENT");
		--Perl_Party_UpdateDisplay();
	end
end

-- PLAYER_ENTERING_WORLD
function Perl_Party_Events:PLAYER_ENTERING_WORLD()
	Perl_Party_RegisterSome();
	Perl_Party_UpdateDisplay();
end
Perl_Party_Events.PARTY_MEMBERS_CHANGED		= Perl_Party_Events.PLAYER_ENTERING_WORLD;

-- PLAYER_LEAVING_WORLD()
function Perl_Party_Events:PLAYER_LEAVING_WORLD()
	Perl_Party_UnregisterSome();
end

-- PARTY_LEADER_CHANGED
function Perl_Party_Events:PARTY_LEADER_CHANGED()
	Perl_Party_UpdateLeader();
end

Perl_Party_Events.PARTY_LOOT_METHOD_CHANGED	= Perl_Party_Events.PARTY_LEADER_CHANGED;

-- UNIT_COMBAT
function Perl_Party_Events:UNIT_COMBAT()
	if (arg1 == this.partyid) then
		Perl_Party_UpdateCombat();

		if (arg2 == "HEAL") then
			Perl_Party_CombatFlash(0, true, true);
		elseif (arg4 and arg4 > 0) then
			Perl_Party_CombatFlash(0, true);
		end
	end
end

-- UNIT_SPELLMISS
--function Perl_Party_Events:UNIT_SPELLMISS()
--	if (arg1 == this.partyid) then
--		Perl_Party_UpdateCombat();
--	end
--end

-- UNIT_HEALTH, UNIT_MAXHEALTH
function Perl_Party_Events:UNIT_HEALTH()
	if (arg1 == this.partyid) then
		Perl_Party_UpdateHealth();
	end
end

-- UNIT_MAXHEALTH
function Perl_Party_Events:UNIT_MAXHEALTH()
	if (arg1 == this.partyid) then
		Perl_Party_UpdateHealth();
		Perl_Party_UpdateLevel();	-- Level not available until we've received maxhealth
	end
end

Perl_Party_Events.PARTY_MEMBER_ENABLE	= Perl_Party_Events.UNIT_HEALTH;
Perl_Party_Events.PARTY_MEMBER_DISABLE	= Perl_Party_Events.UNIT_HEALTH;

-- UNIT_MODEL_CHANGED
function Perl_Party_Events:UNIT_MODEL_CHANGED()
	if (arg1 == this.partyid) then
		Perl_Party_UpdatePortrait();
	end
end
Perl_Party_Events.UNIT_PORTRAIT_UPDATE = Perl_Party_Events.UNIT_MODEL_CHANGED;

-- UNIT_MANA
function Perl_Party_Events:UNIT_MANA()
	if (arg1 == this.partyid) then
		Perl_Party_UpdateMana();
        	--Perl_Party_UpdateCombat();
	end
end

Perl_Party_Events.UNIT_MAXMANA		= Perl_Party_Events.UNIT_MANA;
Perl_Party_Events.UNIT_RAGE		= Perl_Party_Events.UNIT_MANA;
Perl_Party_Events.UNIT_MAXRAGE		= Perl_Party_Events.UNIT_MANA;
Perl_Party_Events.UNIT_ENERGY		= Perl_Party_Events.UNIT_MANA;
Perl_Party_Events.UNIT_MAXENERGY	= Perl_Party_Events.UNIT_MANA;
Perl_Party_Events.UNIT_FOCUS		= Perl_Party_Events.UNIT_MANA;
Perl_Party_Events.UNIT_MAXFOCUS		= Perl_Party_Events.UNIT_MANA;

-- UNIT_DISPLAYPOWER
function Perl_Party_Events:UNIT_DISPLAYPOWER()
	if (arg1 == this.partyid) then
		Perl_Party_UpdateManaType();
		Perl_Party_UpdateMana();
	end
end

-- UNIT_NAME_UPDATE
function Perl_Party_Events:UNIT_NAME_UPDATE()
	if (arg1 == this.partyid) then
		Perl_Party_UpdateName();
	end
end

-- UNIT_LEVEL
function Perl_Party_Events:UNIT_LEVEL()
	if (arg1 == this.partyid) then
		Perl_Party_UpdateLevel();
	end
end

-- UNIT_AURA
function Perl_Party_Events:UNIT_AURA()
	if (arg1 == this.partyid) then
		Perl_Party_Buff_UpdateAll();
		--Perl_Party_UpdateCombat();
	end
end

-- UNIT_FACTION
function Perl_Party_Events:UNIT_FACTION()
	if (arg1 == this.partyid) then
		Perl_Party_UpdateName();
        	Perl_Party_UpdateCombat();
		Perl_Party_Update_Control();
		Perl_Party_UpdatePVP();
	end
end

Perl_Party_Events.UNIT_FLAGS = Perl_Party_Events.UNIT_FACTION;
Perl_Party_Events.UNIT_DYNAMIC_FLAGS = Perl_Party_Events.UNIT_FACTION;

-- Moving stuff
function Perl_Party_GetGap()
	return math.floor(math.floor((Perl_party1:GetBottom() - Perl_party2:GetTop() + 0.01) * 100) / 100);
end

function Perl_Party_SetGap(newGap)
	if (type(newGap) ~= "number") then
		return;
	end

	local top = Perl_party1:GetTop();
	local height = Perl_party1:GetHeight();

	if (type(newGap) == "number") then
		for i = 1,4 do
			local frame = getglobal("Perl_party"..i);
			local left = frame:GetLeft();

			frame:ClearAllPoints();
			frame:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", left, top);

			top = top - (newGap + height);

			frame:StartMoving();
			frame:StopMovingOrSizing();
		end
	end
end

function Perl_Party_AlignLeft()
	local left = Perl_party1:GetLeft();

	for i = 1,4 do
		local frame = getglobal("Perl_party"..i);

		local top = frame:GetTop();

		frame:ClearAllPoints();
		frame:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", left, top);

		frame:StartMoving();
		frame:StopMovingOrSizing();
	end
end

function Perl_SetBuffSize(prefix, sizeBuff, sizeDebuff)
	for i = 1,20 do
		local buff = getglobal(prefix.."BuffFrame_Buff"..i);
		if (buff) then
			buff:SetHeight(sizeBuff);
			buff:SetWidth(sizeBuff);
		end

		local buff = getglobal(prefix.."BuffFrame_DeBuff"..i);
		if (buff) then
			buff:SetHeight(sizeDebuff);
			buff:SetWidth(sizeDebuff);
		end
	end
end

-- Perl_Party_Set_Bits
function Perl_Party_Set_Bits()
	for num=1,4 do
		local levelFrame = getglobal("Perl_party"..num.."_LevelFrame");
		local nameFrame = getglobal("Perl_party"..num.."_NameFrame");
		local statsFrame = getglobal("Perl_party"..num.."_StatsFrame");
		local portraitFrame = getglobal("Perl_party"..num.."_PortraitFrame");
		local clickFrame = getglobal("Perl_party"..num.."_NameFrame_CastClickOverlay");
		local classTexture = getglobal("Perl_party"..num.."_LevelFrame_ClassTexture");
		local levelText = getglobal("Perl_party"..num.."_LevelFrame_LevelBarText");

		portraitFrame:ClearAllPoints();
		nameFrame:ClearAllPoints();
		levelFrame:ClearAllPoints();
		statsFrame:ClearAllPoints();
		classTexture:ClearAllPoints();
		levelText:ClearAllPoints();
		clickFrame:ClearAllPoints();

		if (Perl_Config.ShowPartyPortrait==0) then
			portraitFrame:Hide();

			levelFrame:SetWidth(30);
			levelFrame:SetHeight(41);

			nameFrame:SetPoint("TOPLEFT", getglobal("Perl_party"..num), "TOPLEFT", 0, 0);
			levelFrame:SetPoint("TOPLEFT", nameFrame, "BOTTOMLEFT", 0, 3);
			statsFrame:SetPoint("TOPLEFT", levelFrame, "TOPRIGHT", -3, 0);

			levelText:SetPoint("BOTTOM", levelFrame, "BOTTOM", 0, 4);
			classTexture:SetPoint("TOPLEFT", levelFrame, "TOPLEFT", 5, -5);

			getglobal("Perl_party"..num.."_BuffFrame"):SetPoint("TOPLEFT", statsFrame, "BOTTOMLEFT", 2, 8);

			clickFrame:SetPoint("TOPLEFT", nameFrame, "TOPLEFT", 0, 0);
			clickFrame:SetPoint("BOTTOMRIGHT", statsFrame, "BOTTOMRIGHT", 0, 0);
		else
			portraitFrame:Show();

			levelFrame:SetWidth(27);
			levelFrame:SetHeight(22);

			levelFrame:SetPoint("TOPLEFT", getglobal("Perl_party"..num), "TOPLEFT", 0, 0);
			portraitFrame:SetPoint("TOPLEFT", levelFrame, "TOPRIGHT", -2, 0);
			nameFrame:SetPoint("TOPLEFT", portraitFrame, "TOPRIGHT", -3, 0);
			statsFrame:SetPoint("TOPLEFT", nameFrame, "BOTTOMLEFT", 0, 3);

			levelText:SetPoint("CENTER", 0, 0);
			classTexture:SetPoint("BOTTOMRIGHT", portraitFrame, "BOTTOMLEFT", 0, 3);

			getglobal("Perl_party"..num.."_BuffFrame"):SetPoint("TOPLEFT", portraitFrame, "BOTTOMLEFT", 2, 8);

			clickFrame:SetPoint("TOPLEFT", levelFrame, "TOPLEFT", 0, 0);
			clickFrame:SetPoint("BOTTOMRIGHT", statsFrame, "BOTTOMRIGHT", 0, 0);
		end

		if (Perl_Config.ShowPartyLevel==0) then
			getglobal("Perl_party"..num.."_LevelFrame_LevelBarText"):Hide();
			if (Perl_Config.ShowPartyLevel==1) then
				levelFrame:SetHeight(levelFrame:GetHeight()-10);
			end
		else
			getglobal("Perl_party"..num.."_LevelFrame_LevelBarText"):Show();
			levelFrame:Show();

			if (Perl_Config.ShowPartyLevel==0) then
				levelFrame:SetHeight(levelFrame:GetHeight()+10);
			end

			if (Perl_Config.ShowPartyPortrait == 1) then
				levelFrame:SetWidth(27);
			else
				levelFrame:SetWidth(30);
			end
		end

		if (Perl_Config.ShowPartyClassIcon==0) then
			classTexture:Hide();

			if (Perl_Config.ShowPartyLevel == 0) then
				levelFrame:SetWidth(1);
				levelFrame:Hide();
			end
		else
			classTexture:Show();
			levelFrame:Show();

			if (Perl_Config.ShowPartyPortrait == 1) then
				levelFrame:SetWidth(27);
			else
				levelFrame:SetWidth(30);
			end
		end

		local frameHealth = getglobal("Perl_party"..num.."_StatsFrame_HealthBarPercent");
		local frameMana = getglobal("Perl_party"..num.."_StatsFrame_ManaBarPercent");
		local width = (30 * Perl_Config.ShowPartyPercent) + 106;	-- 136 enabled, 106 disabled

		statsFrame:SetWidth(width);
		if (Perl_Config.ShowPartyPercent == 0) then
			frameHealth:Hide();
			frameMana:Hide();
		else
			frameHealth:Show();
			frameMana:Show();
		end

		local height = (Perl_Config.ShowPartyNames * 22) + 2;		-- 24 when enabled, 2 when disabled
		local targetFrame = getglobal("Perl_party"..num.."_TargetFrame");

		targetFrame:ClearAllPoints();
		nameFrame:SetHeight(height);

		if (Perl_Config.ShowPartyNames==0) then
			nameFrame:Hide();
			targetFrame:SetPoint("TOPLEFT", statsFrame, "BOTTOMLEFT", 0, 2);
		else
			nameFrame:Show();
			targetFrame:SetPoint("BOTTOMLEFT", nameFrame, "BOTTOMRIGHT", -2, 2);
		end

		Perl_Config.PartyBuffSize = tonumber(Perl_Config.PartyBuffSize) or 20;
		Perl_SetBuffSize("Perl_party"..num.."_", Perl_Config.PartyBuffSize, Perl_Config.PartyBuffSize * 1.4);
	end
end
