local function MinMaxScale(arg)
	arg = tonumber(arg);
	if (arg < 0.5) then
		arg = 0.5
	elseif (arg > Perl_Config.MaximumScale) then
		arg = Perl_Config.MaximumScale;
	end
	return arg;
end

local function Perl_SlashHandler(msg)
	local args = {};
	local BLU = "|c000000FF";
	local CYN = "|c0000A0A0";
	local MAG = "|c00800080";
	local RED = "|c00FF0000";
	local DKRED = "|c007F0000";
	local GRN = "|c0000FF00";
	local DKGRN = "|c00007F00";
	local YELLOW = "|c00FFFF00";
	local CLR = "|r";

	for value in string.gfind(msg, "[^ ]+") do
		table.insert(args, string.lower(value));
	end
	if (args[1]=="") then
		Perl_OptionsMenu_Frame:Show();
		return;
	end

	local enable = 0;
	if (args[2]) then
		if (args[2] == "on" or args[2] == "show" or args[2] == "true" or args[2] == "1") then
			enable = 1;
		end
	end

	local SimpleOptions = {
		["playerportrait"] = "ShowPlayerPortrait",
		["portrait3d"] = "ShowPlayerPortrait3D",
		["counters"] = "TargetCounters",
		["combatflash"] = "CombatFlash",
		["fadeframes"] = "PerlFadeFrames",
		["highlight"] = "HighlightSelection",
		["counthealersonly"] = "TargetCountersSelf",
		["enemycounters"] = "TargetCountersEnemy",
		["playerlevel"] = "ShowPlayerLevel=enable;",
		["playerclass"] = "ShowPlayerClassIcon",
		["targetportrait"] = "ShowTargetPortrait",
		["targetmobtype"] = "ShowTargetMobType",
		["targetlevel"] = "ShowTargetLevel",
		["targetmana"] = "ShowTargetMana",
		["targetelite"] = "ShowTargetElite",
		["targetclass"] = "ShowTargetClassIcon",
		["hitindicator"] = "CombatHitIndicator",
		["partylevel"] = "ShowPartyLevel",
		["partyicon"] = "ShowPartyClassIcon",
		["partyvalues"] = "ShowPartyValues",
		["partypercent"] = "ShowPartyPercent",
		["partynames"] = "ShowPartyNames",
		["partytarget"] = "ShowPartyTarget",
		["partybuffs"] = "PartyBuffs",
		["partydebuffs"] = "PartyDebuffs",
		["classcolours"] = "ClassColouredNames",
		["classcolors"] = "ClassColouredNames",
		["petlevel"] = "ShowPetLevel",
		["pethappiness"] = "PetHappiness",
		["playerxp"] = "ShowPlayerXPBar",
		["playerrank"] = "ShowPlayerPVPRank",
		["targetrank"] = "ShowTargetPVPRank",
		["arcanebar"] = "ArcaneBar",
		["oldcastbar"] = "OldCastBar",
		["partyinraid"] = "ShowPartyRaid",
		["targettarget"] = "ShowTargetTarget",
		["targethistory"] = "TargetTargetHistory",
		["petxp"] = "ShowPetXP",
		["targettargetbuffs"] = "TargetTargetBuffs",
		["target30yard"] = "Show30YardSymbol",
		["casttime"] = "CastTime",
		["partynumber"] = "ShowPartyNumber",
		["raidpercent"] = "ShowRaidPercents",
		["group1"] = "ShowGroup1",
		["group2"] = "ShowGroup2",
		["group3"] = "ShowGroup3",
		["group4"] = "ShowGroup4",
		["group5"] = "ShowGroup5",
		["group6"] = "ShowGroup6",
		["group7"] = "ShowGroup7",
		["group8"] = "ShowGroup8",
		["group9"] = "ShowGroup9",
		["minimapbutton"] = "MinimapButtonShown"
	}

	local foundSimple = SimpleOptions[args[1]];

	if (foundSimple) then
		Perl_Config[foundSimple] = enable;
	else
		if  (args[1]=="lock") then
			Perl_LockFrames();

		elseif (args[1] == nil or args[1] == "menu" or args[1] == "options" or args[1]=="unlock") then
			Perl_UnlockFrames()

		--elseif ((args[1]=="menu") or (args[1] == "options")) then
        	        --Perl_OptionsMenu_Frame:Show();
			--return;

		elseif (args[1]=="usecptext") then
			Perl_Config.UseCPMeter=0;
		elseif (args[1]=="usecpmeter") then
			Perl_Config.UseCPMeter=1;
		elseif (args[1]=="nobartextures") then
			Perl_Config.BarTextures=0;
		elseif (args[1]=="bartextures") then
			Perl_Config.BarTextures=1;

		elseif (args[1]=="settexttrans") then
			Perl_Config.TextTransparency = tonumber(args[2]);
		elseif (args[1]=="settrans") then
			Perl_Config.Transparency = tonumber(args[2]);

		elseif (args[1]=="setplayerscale") then
			Perl_Config.Scale_PlayerFrame = MinMaxScale(args[2]);
		elseif (args[1]=="setpetscale") then
			Perl_Config.Scale_PetFrame = MinMaxScale(args[2]);
		elseif (args[1]=="setpartyscale") then
			Perl_Config.Scale_PartyFrame = MinMaxScale(args[2]);
		elseif (args[1]=="setpartypetscale") then
			Perl_Config.Scale_PartyPets = MinMaxScale(args[2]);
		elseif (args[1]=="settargetscale") then
			Perl_Config.Scale_TargetFrame = MinMaxScale(args[2]);
		elseif (args[1]=="settargettargetscale") then
			Perl_Config.Scale_TargetTargetFrame = MinMaxScale(args[2]);

		elseif (args[1]=="castparty" and (args[2]=="show" or args[2] == "hide")) then
			Perl_Config.CastPartyShow = enable;
		elseif (args[1]=="castparty" and (args[2]=="on" or args[2] == "off")) then
			Perl_Config.CastParty = enable;

		elseif (args[1]=="partydebuffs" and args[2]=="below") then
			Perl_Config.PartyDebuffsBelow=1;
		elseif (args[1]=="partydebuffs" and args[2]=="right") then
			Perl_Config.PartyDebuffsBelow=0;

		elseif (args[1]=="raidbyclass") then
			Perl_Config.SortRaidByClass=1;
		elseif (args[1]=="raidbygroup") then
			Perl_Config.SortRaidByClass=0;

		elseif (args[1]=="raid") then
			Perl_Config.ShowRaid = enable;
			for i = 1,10 do
				Perl_Config["ShowRaid"..i] = enable;
			end

		elseif (args[1]=="setraidscale") then
			Perl_Config.Scale_Raid = MinMaxScale(args[2]);

		elseif (args[1]=="backcolor" or args[1]=="bordercolor" or args[1]=="backcolour" or args[1]=="bordercolour") then
			local r = tonumber(args[2]);
			local g = tonumber(args[3]);
			local b = tonumber(args[4]);

			if (r >= 0 and r <= 1) then
				if (g >= 0 and g <= 1) then
					if (b >= 0 and b <= 1) then
						if (args[1]=="backcolor" or args[1]=="backcolour") then
							Perl_Config.BackColour.r = r;
							Perl_Config.BackColour.g = g;
							Perl_Config.BackColour.b = b;
						else
							Perl_Config.BorderColour.r = r;
							Perl_Config.BorderColour.g = g;
							Perl_Config.BorderColour.b = b;
						end
					end
				end
			end

		elseif (args[1]=="simpleframes" or args[1]=="complexframes") then
			if (args[1]=="simpleframes") then
				enable = 0;
			else
				enable = 1;
			end

			Perl_Config.ShowPlayerPortrait = enable;
			Perl_Config.ShowPlayerLevel = enable;
			Perl_Config.ShowPlayerClassIcon = enable;
			Perl_Config.ShowTargetClassIcon = enable;
			Perl_Config.ShowTargetPortrait = enable;
			Perl_Config.ShowTargetMobType = enable;
			Perl_Config.ShowTargetLevel = enable;
			Perl_Config.ShowTargetElite = enable;
			Perl_Config.ShowPartyLevel = enable;
			Perl_Config.ShowPartyClassIcon = enable;
			Perl_Config.ShowPartyPercent = enable;
			Perl_Config.ShowPetLevel = enable;
			Perl_Config.PetHappiness = enable;

		elseif (args[1] == "basichelp" or args[1] == "help") then
			DEFAULT_CHAT_FRAME:AddMessage("/perl "..CYN.."lock"..CLR.." /perl "..CYN.."unlock"..CLR.." /perl "..CYN.."menu");
			DEFAULT_CHAT_FRAME:AddMessage("/perl "..CYN.."simpleframes"..CLR.." /perl "..CYN.."complexframes");
			DEFAULT_CHAT_FRAME:AddMessage("/perl "..CYN.."showhidehelp"..CLR.." /perl "..CYN.."settexttrans "..YELLOW.."#");
			DEFAULT_CHAT_FRAME:AddMessage("/perl "..CYN.."settrans "..YELLOW.."#"..CLR.." /perl "..CYN.."settargetscale "..YELLOW.."#");
			DEFAULT_CHAT_FRAME:AddMessage("/perl "..CYN.."setpartyscale "..YELLOW.."#"..CLR.." /perl "..CYN.."setplayerscale "..YELLOW.."#");
			DEFAULT_CHAT_FRAME:AddMessage("/perl "..CYN.."setpetscale "..YELLOW.."#"..CLR.." /perl "..CYN.."settargettargetscale "..YELLOW.."#");
			DEFAULT_CHAT_FRAME:AddMessage("/perl "..CYN.."usecptext"..CLR.." /perl "..CYN.."bartextures"..CLR.." /perl "..CYN.."usecpmeter");
			DEFAULT_CHAT_FRAME:AddMessage("/perl "..CYN.."nobartextures"..CLR.." /perl "..CYN.."castparty "..YELLOW.."on/off");
			DEFAULT_CHAT_FRAME:AddMessage("/perl "..CYN.."targettarget "..YELLOW.."on"..CLR.." /perl "..CYN.."targethistory "..YELLOW.."on/off");
			DEFAULT_CHAT_FRAME:AddMessage("/perl "..CYN.."portrait3d "..YELLOW.."hide/show"..CLR.." /perl "..CYN.."counters "..YELLOW.."on/off");
			DEFAULT_CHAT_FRAME:AddMessage("/perl "..CYN.."enemycounters "..YELLOW.."on/off"..CLR.." /perl "..CYN.."counthealersonly "..YELLOW.."on/off");
			DEFAULT_CHAT_FRAME:AddMessage("/perl "..CYN.."combatflash "..YELLOW.."on/off");
			DEFAULT_CHAT_FRAME:AddMessage("/perl "..CYN.."partynumber "..YELLOW.."on/off"..CLR.." /perl "..CYN.."targettargetbuffs "..YELLOW.."on/off");
			DEFAULT_CHAT_FRAME:AddMessage("/perl "..CYN.."backcolor "..RED.."r "..GRN.."g "..BLU.."b"..CLR.." /perl "..CYN.."bordercolor "..RED.."r "..GRN.."g "..BLU.."b");
			DEFAULT_CHAT_FRAME:AddMessage("/perl "..CYN.."hitindicator "..YELLOW.."on/off"..CLR.." /perl "..CYN.."partybuffs "..YELLOW.."on/off");
			DEFAULT_CHAT_FRAME:AddMessage("/perl "..CYN.."partydebuffs "..YELLOW.."on/off"..CLR.." /perl "..CYN.."minimapbutton "..YELLOW.."on/off");
			DEFAULT_CHAT_FRAME:AddMessage("/perl "..CYN.."highlight "..YELLOW.."on/off"..CLR.." /perl "..CYN.."fadeframes "..YELLOW.."on/off");

		elseif (args[1]=="showhidehelp") then
			DEFAULT_CHAT_FRAME:AddMessage("Use /perl target show/hide");
			DEFAULT_CHAT_FRAME:AddMessage("For example, to hide the player level, use");
			DEFAULT_CHAT_FRAME:AddMessage("/perl playerlevel hide --make sure your only space is directly after 'perl'.");
			DEFAULT_CHAT_FRAME:AddMessage("Valid Targets:");
			DEFAULT_CHAT_FRAME:AddMessage("playerportrait  "..CYN.."targetportrait"..CLR.."    partyicon");
			DEFAULT_CHAT_FRAME:AddMessage(CYN.."playerlevel"..CLR.."     targetlevel        "..CYN.."partylevel"..CLR.."         petlevel");
			DEFAULT_CHAT_FRAME:AddMessage("playerclass    "..CYN.."targetmobtype"..CLR.."  partypercent    "..CYN.."partyvalues");
			DEFAULT_CHAT_FRAME:AddMessage(CYN.."playerxp"..CLR.."         targetmana       "..CYN.."partyinraid"..CLR.."       castparty");
			DEFAULT_CHAT_FRAME:AddMessage("playerrank      "..CYN.."targetrank"..CLR.."        partynames      "..CYN.."blizzardplayer");
			DEFAULT_CHAT_FRAME:AddMessage(CYN.."targetclass"..CLR.."     targetelite         "..CYN.."arcanebar"..CLR.."        oldcastbar");
			DEFAULT_CHAT_FRAME:AddMessage("partytarget      "..CYN.."petxp"..CLR.."                pethappiness");
			DEFAULT_CHAT_FRAME:AddMessage("Note that /perl simpleframes or complexframes may override these settings.");
		else
			DEFAULT_CHAT_FRAME:AddMessage("Unknown command, type /perl "..CYN.."help");
		end
	end

	Perl_OptionActions();
end

function Perl_SlashOnLoad()
        SlashCmdList["PERL"] = Perl_SlashHandler;
        SLASH_PERL1 = "/perl";
end
