----------------------
-- Loading Function --
----------------------

Perl_TargetHistory = {}

function Perl_TargetTarget_OnLoad()
	this.unitid = "targettarget";
	if (this:GetName() == "Perl_TargetTargetTarget") then
		this.unitid = "targettargettarget";
	else
		Perl_TargetTarget_Frame = Perl_TargetTarget;
	end

	-- Events
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("PLAYER_LEAVING_WORLD");

	--table.insert(UnitPopupFrames, this:GetName().."_DropDown");

	this.time = 0;
	this.targetname = "";
	this.targethp = 0;
	this.targetmana = 0;
	this.lastUpdate = 0;

	this.SubFrame = function(this, a)
		return getglobal(this:GetName().."_"..a);
	end

	Perl_InitFadeFrame(this);

	getglobal(this:GetName().."_BuffFrame_Buff1"):SetPoint("TOPLEFT", 0, 0);
	getglobal(this:GetName().."_BuffFrame_DeBuff1"):SetPoint("TOPLEFT", 0, 0);

	if (Perl_Config and Perl_Config.ConfigVersion) then
		Perl_SetupFrame(getglobal(this:GetName().."_StatsFrame"));
		Perl_SetupFrame(getglobal(this:GetName().."_NameFrame"));
		Perl_SetupFrame(getglobal(this:GetName().."_LevelFrame"));
	       	getglobal(this:GetName().."_NameFrame_PVPRankIcon"):SetAlpha(0.3);
	end
end

local function Perl_TargetTarget_RegisterSome()
	this:RegisterEvent("RAID_TARGET_UPDATE");

	if (this == Perl_TargetTarget) then
		this:RegisterEvent("PLAYER_TARGET_CHANGED");
		this:RegisterEvent("UNIT_HEALTH");			-- So health updates are more regular
		this:RegisterEvent("UNIT_MAXHEALTH");
		this:RegisterEvent("UNIT_AURA");
		this:RegisterEvent("UNIT_FACTION");
	end
end
local function Perl_TargetTarget_UnregisterSome()
	this:UnregisterEvent("RAID_TARGET_UPDATE");

	if (this == Perl_TargetTarget) then
		this:UnregisterEvent("PLAYER_TARGET_CHANGED");
		this:UnregisterEvent("UNIT_HEALTH");
		this:UnregisterEvent("UNIT_MAXHEALTH");
		this:UnregisterEvent("UNIT_AURA");
		this:UnregisterEvent("UNIT_FACTION");
	end
end

-------------------------
-- The Update Function --
-------------------------
function Perl_TargetTarget_UpdatePVP(ttFrame)
        local targetrankname, targetrank=GetPVPRankInfo(UnitPVPRank(ttFrame.unitid), ttFrame.unitid);
        if (targetrank and Perl_Config.ShowTargetPVPRank==1 and UnitIsPlayer(ttFrame.unitid)) then
                ttFrame:SubFrame("NameFrame_PVPRankIcon"):Show();
		if (targetrank==0) then
                        ttFrame:SubFrame("NameFrame_PVPRankIcon"):Hide();
		else
			ttFrame:SubFrame("NameFrame_PVPRankIcon"):SetTexture(string.format("Interface\\PVPRankBadges\\PVPRank%02d", targetrank));
		end
	else
                ttFrame:SubFrame("NameFrame_PVPRankIcon"):Hide();
	end
        if (UnitIsPVP("targettarget")) then
		ttFrame:SubFrame("NameFrame_PVPStatus"):SetTexture("Interface\\TargetingFrame\\UI-PVP-"..(UnitFactionGroup("targettarget") or "FFA"));
                ttFrame:SubFrame("NameFrame_PVPStatus"):Show();
	else
                ttFrame:SubFrame("NameFrame_PVPStatus"):Hide();
	end
end

local function Perl_TargetTarget_Buff_UpdateAll(ttFrame)
	local show;
	if (ttFrame == Perl_TargetTarget) then
		show = Perl_Config.TargetTargetBuffs;
	else
		show = Perl_Config.TargetTargetTargetBuffs;
	end

	if (show == 1) then
		ttFrame:SubFrame("BuffFrame"):Show();
		Perl_Targets_BuffUpdate(ttFrame.unitid, ttFrame:GetName().."_", ttFrame);
	else
		ttFrame:SubFrame("BuffFrame"):Hide();
	end
end

local function Perl_TargetTarget_RaidIconUpdate(unitid, frameRaidIcon, frameNameFrame)
	Perl_Update_RaidIcon(unitid, frameRaidIcon);

	frameRaidIcon:ClearAllPoints();
	if (Perl_Config.AlternateRaidIcon == 1) then
		frameRaidIcon:SetHeight(16);
		frameRaidIcon:SetWidth(16);
		frameRaidIcon:SetPoint("CENTER", frameNameFrame, "TOPRIGHT", -5, -4);
	else
		frameRaidIcon:SetHeight(32);
		frameRaidIcon:SetWidth(32);
		frameRaidIcon:SetPoint("CENTER", frameNameFrame, "CENTER", 0, 0);
	end
end

function Perl_TargetTarget_UpdateDisplay(ttFrame,force)

	local show;
	if (ttFrame == Perl_TargetTarget) then
		show = Perl_Config.ShowTargetTarget;
	else
		show = Perl_Config.ShowTargetTargetTarget;
		if (show == 1 and Perl_Config.ShowTargetTarget == 0) then
			show = 0;
		end
	end

	if (UnitExists("target") and show == 1 and UnitIsConnected(ttFrame.unitid)) then		-- (UnitName("target")~=nil) and (show==1) and (UnitIsConnected(ttFrame.unitid))) then
		ttFrame.targetname = UnitName(ttFrame.unitid);
		if (ttFrame.targetname ~= nil) then
			local t = GetTime();
			if (not force and t < ttFrame.lastUpdate + 0.3) then
				return;
			end
			ttFrame.lastUpdate = t;

			Perl_CancelFade(ttFrame);
			ttFrame:Show();

	                Perl_TargetTarget_UpdatePVP(ttFrame);

			-- Save these 2, so we know whether to update the frame later
			ttFrame.targethp = UnitHealth(ttFrame.unitid);
			ttFrame.targetmana = UnitMana(ttFrame.unitid);

                        Perl_SetUnitNameColor(ttFrame.unitid, ttFrame:SubFrame("NameFrame_NameBarText"));

                        if (Perl_Config.ShowTargetTargetLevel == 1) then
				local TargetTargetlevel = UnitLevel(ttFrame.unitid);
	                        local color = GetDifficultyColor(TargetTargetlevel);

				if (TargetTargetLevel == -1) then
					if (UnitClassification(ttFrame.unitid) == "worldboss") then
						TargetTargetLevel = "Boss";
					end
				elseif (UnitIsPlusMob(ttFrame.unitid) or UnitClassification(ttFrame.unitid) == "elite") then
                                        TargetTargetlevel = TargetTargetlevel.."+";
                                        ttFrame:SubFrame("LevelFrame"):SetWidth(33);
                                else
                                        ttFrame:SubFrame("LevelFrame"):SetWidth(27);
                                end

				ttFrame:SubFrame("LevelFrameText"):SetText(TargetTargetlevel);

				if (TargetTargetLevel == "Boss") then
                                        ttFrame:SubFrame("LevelFrame"):SetWidth(ttFrame:SubFrame("LevelFrameText"):GetStringWidth() + 6);
					color = {r = 1, g = 0, b = 0};
				end

				if (Perl_Config.ShowTargetTargetPercent == 1) then
					ttFrame:SubFrame("NameFrame"):SetWidth(163 - ttFrame:SubFrame("LevelFrame"):GetWidth());
				else
					ttFrame:SubFrame("NameFrame"):SetWidth(131 - ttFrame:SubFrame("LevelFrame"):GetWidth());
				end

        	                ttFrame:SubFrame("LevelFrameText"):SetTextColor(color.r, color.g, color.b);
                        end

			-- Set name - Must do after level as the NameFrame can change size just above here.
			local TargetTargetname = ttFrame.targetname;
			ttFrame:SubFrame("NameFrame_NameBarText"):SetText(TargetTargetname);

			local remCount = 1;
			while ((ttFrame:SubFrame("NameFrame_NameBarText"):GetStringWidth() >= (ttFrame:SubFrame("NameFrame"):GetWidth() - 8)) and (string.len(TargetTargetname) > remCount)) do
				TargetTargetname = string.sub(TargetTargetname, 1, string.len(TargetTargetname) - remCount).."..";
				remCount = 3;
				ttFrame:SubFrame("NameFrame_NameBarText"):SetText(TargetTargetname);
			end

			-- Set health
			Perl_Target_SetHealth(ttFrame.unitid, ttFrame:SubFrame("StatsFrame_HealthBar"), ttFrame:SubFrame("StatsFrame_HealthBarBG"), ttFrame:SubFrame("StatsFrame_HealthBarPercent"), ttFrame:SubFrame("StatsFrame_HealthBarText"), ttFrame:SubFrame("StatsFrame_ManaBarPercent"), Perl_Config.ShowTargetTargetPercent);

			-- Set mana
			Perl_Target_SetManaType(ttFrame.unitid, ttFrame:SubFrame("StatsFrame_ManaBar"), ttFrame:SubFrame("StatsFrame_ManaBarText"), ttFrame:SubFrame("StatsFrame_ManaBarBG"), ttFrame:SubFrame("StatsFrame"), ttFrame);
			Perl_Target_SetMana(ttFrame.unitid, ttFrame:SubFrame("StatsFrame_ManaBar"), ttFrame:SubFrame("StatsFrame_HealthBarPercent"), ttFrame:SubFrame("StatsFrame_ManaBarPercent"), ttFrame:SubFrame("StatsFrame_ManaBarText"));

			if (Perl_Config.ShowTargetTargetValues == 1) then
				ttFrame:SubFrame("StatsFrame_HealthBarText"):Show();
				ttFrame:SubFrame("StatsFrame_ManaBarText"):Show();
			else
				ttFrame:SubFrame("StatsFrame_HealthBarText"):Hide();
				ttFrame:SubFrame("StatsFrame_ManaBarText"):Hide();
			end

			Perl_TargetTarget_RaidIconUpdate(ttFrame.unitid, ttFrame:SubFrame("NameFrame_RaidIcon"), ttFrame:SubFrame("NameFrame"));

			Perl_Targets_BuffPositions(ttFrame.unitid, ttFrame:GetName().."_", ttFrame);
			Perl_TargetTarget_Buff_UpdateAll(ttFrame);

			return;
		else
			ttFrame.targetname = "";
		end
	else
		ttFrame.targetname = "";
	end

	Perl_StartFade(ttFrame);
end

local function Perl_TargetTarget_Update_Control(ttFrame)
        if (UnitIsVisible(ttFrame.unitid) and UnitIsCharmed(ttFrame.unitid)) then
		ttFrame:SubFrame("NameFrame_Warning"):Show();
	else
		ttFrame:SubFrame("NameFrame_Warning"):Hide();
	end
end

local function Perl_TargetTarget_Update_Combat(ttFrame)
        if (UnitAffectingCombat(ttFrame.unitid)) then
                ttFrame:SubFrame("NameFrame_ActivityStatus"):Show();
        else
                ttFrame:SubFrame("NameFrame_ActivityStatus"):Hide();
        end
end

local function Perl_TargetTarget_AddHistory(newName, r, g, b)
	if (table.getn(Perl_TargetHistory) == 0 or newName ~= Perl_TargetHistory[1].name) then
		table.insert(Perl_TargetHistory, 1, {["name"] = newName, ["r"] = r, ["g"] = g, ["b"] = b, ["time"] = GetTime()});

		while (table.getn(Perl_TargetHistory) > 10) do
			table.remove(Perl_TargetHistory, 11);
		end
		Perl_TargetTarget.FlashChangeStart = GetTime();
	end
end

local function Process_HistoryFlash()
	if (not this.FlashChangeStart) then
		return;
	end

	local timer = (GetTime() - this.FlashChangeStart);
	local r, g, b;
	if (timer > 1) then
		this.FlashChangeStart = nil;
		r = Perl_Config.BorderColour.r;
		g = Perl_Config.BorderColour.g;
		b = Perl_Config.BorderColour.b;
	else
		r = Perl_Config.BorderColour.r + 0.5 - (timer / 2);
		g = Perl_Config.BorderColour.g + 0.5 - (timer / 2);
		b = Perl_Config.BorderColour.b + 0.5 - (timer / 2);

		if (r < 0) then r = 0; elseif (r > 1) then r = 1; end
		if (g < 0) then g = 0; elseif (g > 1) then g = 1; end
		if (b < 0) then b = 0; elseif (b > 1) then b = 1; end
	end

	this:SubFrame("NameFrame"):SetBackdropBorderColor(r, g, b, Perl_Config.Transparency);
	this:SubFrame("StatsFrame"):SetBackdropBorderColor(r, g, b, Perl_Config.Transparency);
	this:SubFrame("LevelFrame"):SetBackdropBorderColor(r, g, b, Perl_Config.Transparency);

	if (this == Perl_TargetTarget) then
		if (Perl_TargetTarget_History1) then
			Perl_TargetTarget_History1:SetBackdropBorderColor(r, g, b, Perl_Config.Transparency);
		end
	end
end

function Perl_TargetTarget_OnUpdate(elapsed, ttFrame)
	--if (not ttFrame.unitid) then
	--	return;
	--end

	local newName = UnitName(ttFrame.unitid);
	local newHP = UnitHealth(ttFrame.unitid);
	local newMana = UnitMana(ttFrame.unitid);

	if (not newName) then
		newName = "";
		newHP = 0;
		newMana = 0;
	end

	if (newName ~= ttFrame.targetname) then
		if (ttFrame == Perl_TargetTarget) then
			if (not UnitIsUnit("player", "target")) then
				if (ttFrame.targetname ~= "") then
					if (newName ~= "") then
						local r, g, b = ttFrame:SubFrame("NameFrame_NameBarText"):GetTextColor();
						Perl_TargetTarget_AddHistory(Perl_TargetTarget.targetname, r, g, b);
					end
				end
			end
		end

		Perl_TargetTarget_UpdateDisplay(ttFrame,true);

	elseif ((newHP ~= ttFrame.targethp) or (newMana ~= ttFrame.targetmana)) then
		Perl_TargetTarget_UpdateDisplay(ttFrame);
	end

	if (Perl_Config.TargetTargetHistory == 1) then
		if (ttFrame == Perl_TargetTarget) then
			Perl_TargetTarget_Update();
		end
	else
		Process_HistoryFlash();

		if (ttFrame == Perl_TargetTarget) then
			Perl_TargetTarget_HideHistory();
		end
	end

	ttFrame.time = elapsed + ttFrame.time;
        if (ttFrame.time >= 0.3 and ttFrame.Fading == 0) then
		if (newName ~= "") then
			if (ttFrame:IsShown()) then
	                	Perl_TargetTarget_Update_Combat(ttFrame);
				Perl_TargetTarget_Update_Control(ttFrame);
	                	Perl_TargetTarget_UpdatePVP(ttFrame);
				Perl_TargetTarget_Buff_UpdateAll(ttFrame);
				Perl_SetUnitNameColor(ttFrame.unitid, ttFrame:SubFrame("NameFrame_NameBarText"));
			end
		end

		ttFrame.time = 0;
	end

	Perl_ProcessFade(ttFrame);
end

--------------------
-- Click Handlers --
--------------------
function Perl_TargetTarget_PlayerTip()
	--GameTooltip_SetDefaultAnchor(GameTooltip, this);
	--GameTooltip:SetUnit("targettarget");
	Perl_Options_SelectFrame("player");
	Perl_PlayerTip("targettarget");
end

--[[
local function Perl_TargetTargetDropDown_Initialize()
	local frame = this:GetParent();
	if (not frame.unitid) then
		return;
	end

	local menu = nil;
	if ( UnitIsEnemy(frame.unitid, "player") ) then
		return;
	end
	menu = "RAID_TARGET_ICON";
	if ( UnitIsUnit(frame.unitid, "player") ) then
		menu = "SELF";
	elseif ( UnitIsUnit(frame.unitid, "pet") ) then
		menu = "PET";
	elseif ( UnitIsPlayer(frame.unitid) ) then
		if ( UnitInParty(frame.unitid) ) then
			menu = "PARTY";
		else
			menu = "PLAYER";
		end
	end
	if ( menu ) then
		UnitPopup_ShowMenu(this, menu, frame.unitid);
	end
end
]]

--function Perl_TargetTargetDropDown_OnLoad()
--	UIDropDownMenu_Initialize(this, Perl_TargetTargetDropDown_Initialize, "MENU");
--end

function Perl_TargetTarget_OnClick(button)

	if (Perl_OnClick_Handler(button, this:GetParent().unitid)) then
		return;
	end

	--if (button == "RightButton") then
	--	ToggleDropDownMenu(1, nil, getglobal(this:GetParent():GetName().."_DropDown"), this:GetName(), 0, 0);
	--end
end

-------------------
-- Event Handler --
-------------------
function Perl_TargetTarget_OnEvent()

	if (event == "PLAYER_ENTERING_WORLD") then
		Perl_TargetTarget_RegisterSome();
		Perl_TargetTarget_ClearHistory();

	elseif (event == "PLAYER_LEAVING_WORLD") then
		Perl_TargetTarget_UnregisterSome();
		Perl_TargetTarget:Hide();
		if (Perl_TargetTargetTarget) then
			Perl_TargetTargetTarget:Hide();
		end
		return;

	elseif (event == "RAID_TARGET_UPDATE") then
		Perl_TargetTarget_RaidIconUpdate(Perl_TargetTarget.unitid, Perl_TargetTarget_NameFrame_RaidIcon, Perl_TargetTarget_NameFrame);
		if (Perl_TargetTargetTarget) then
			Perl_TargetTarget_RaidIconUpdate(Perl_TargetTargetTarget.unitid, Perl_TargetTarget_NameFrame_RaidIcon, Perl_TargetTarget_NameFrame);
		end

	elseif (event == "PLAYER_TARGET_CHANGED") then
		Perl_TargetTarget_ClearHistory();
	end

	if (unit) then
		if (string.find(event, "UNIT_HEALTH UNIT_MAXHEALTH UNIT_AURA UNIT_FACTION")) then
			if (UnitIsUnit(unit, "targettarget")) then
				Perl_TargetTarget_UpdateDisplay(Perl_TargetTarget,true);
			elseif (Perl_TargetTargetTarget and UnitIsUnit(unit, "targettargettarget")) then
				Perl_TargetTarget_UpdateDisplay(Perl_TargetTargetTarget,true);
			end
		end
	end
end

--------------------
-- Target history --
--------------------

function Perl_TargetTarget_ClearHistory()
	Perl_TargetHistory = {};
	Perl_TargetTarget_Update();
end

function Perl_TargetTarget_Update()

	local alpha = Perl_Config.Transparency;
	local time = GetTime();

	Process_HistoryFlash();

	local offset = -3;
	if (Perl_Config.TargetTargetBuffs == 1) then
		if (UnitName("targettarget")) then
			if (UnitBuff("targettarget", 1)) then
				if (offset == -3) then
					offset = 0;
				end
				offset = offset + 20;
				if (UnitBuff("targettarget", 9)) then
					offset = offset + 20;
				end
			end
			if (UnitDebuff("targettarget", 1)) then
				if (offset == -3) then
					offset = 0;
				end
				offset = offset + 24;
			end
		end
	end

	if (Perl_TargetTarget_History1) then
		Perl_TargetTarget_History1:ClearAllPoints();
		Perl_TargetTarget_History1:SetPoint("TOPLEFT", Perl_TargetTarget_StatsFrame, "BOTTOMLEFT", 0, -offset);
	end

	for i = 1,10 do
		local frame = getglobal("Perl_TargetTarget_History"..i);
		local value = Perl_TargetHistory[i];

		if (value) then
			if (not frame) then
				frame = CreateFrame("Frame", "Perl_TargetTarget_History"..i, UIParent, "Perl_History_Template");
				frame:SetID(i);
				Perl_SetupFrame(frame);
				frame:SetScale(Perl_Config.Scale_TargetTargetFrame);
			end
			if (Perl_Config.ShowTargetTargetPercent == 0) then
				frame:SetWidth(128);
			else
				frame:SetWidth(160);
			end

			local frameText = getglobal("Perl_TargetTarget_History"..i.."_NameBarText");

			frameText:SetText(Perl_TargetHistory[i].name);
			frameText:SetTextColor(Perl_TargetHistory[i].r, Perl_TargetHistory[i].g, Perl_TargetHistory[i].b);
			frame:Show();

			local minAlpha = 0.2;
			local fadeSeconds = 9;
			if (Perl_TargetHistory[i].time < time - (fadeSeconds + 1)) then
				frame:SetAlpha(minAlpha);
			elseif (Perl_TargetHistory[i].time < time - fadeSeconds) then
				local fullRange = Perl_Config.Transparency - minAlpha;
				local fade = (time - Perl_TargetHistory[i].time) - fadeSeconds;
				local alphaItem = Perl_Config.Transparency - (fullRange * fade);

				frame:SetAlpha(alphaItem);
			else
				frame:SetAlpha(Perl_Config.Transparency);
			end

		elseif (frame) then
		    	frame:Hide();
		end
	end
end

function Perl_TargetTarget_ResetFade()
	local time = GetTime();
	for i = 1,table.getn(Perl_TargetHistory) do
		Perl_TargetHistory[i].time = time;
	end
end

function Perl_TargetTarget_History_OnEnter()
	local id = this:GetID();
	if (id) then
		Perl_TargetHistory[id].time = GetTime();
	end
end

function Perl_TargetTarget_History_OnMouseUp()
	local id = this:GetID();

	if (id) then
		if (Perl_TargetHistory[id].name) then
			TargetByName(Perl_TargetHistory[id].name);
		end
	end
end

function Perl_TargetTarget_HideHistory()
	for i = 1,10 do
		local f = getglobal("Perl_TargetTarget_History"..i);
		if (f) then
			f:Hide();
		end
	end
end

function Perl_TargetTarget_Set_Bits()
	if (not Perl_TargetTarget) then
		return;
	end

	local function Set(frame)
		local statsFrame = getglobal(frame:GetName().."_StatsFrame");
		local statsFrameHealthBarPercent = getglobal(statsFrame:GetName().."_HealthBarPercent");
		local statsFrameManaBarPercent = getglobal(statsFrame:GetName().."_ManaBarPercent");
		local nameFrame = getglobal(frame:GetName().."_NameFrame");
		local levelFrame = getglobal(frame:GetName().."_LevelFrame");

		if (Perl_Config.ShowTargetTargetLevel==0) then
			--nameFrame:SetWidth(160);
			levelFrame:Hide();
			levelFrame:SetWidth(3);
		else
			--nameFrame:SetWidth(136);
			levelFrame:Show();
			levelFrame:SetWidth(27);
		end

		if (Perl_Config.ShowTargetTargetPercent == 0) then
			statsFrame:SetWidth(128);
			statsFrameHealthBarPercent:Hide();
			statsFrameManaBarPercent:Hide();

			if (Perl_Config.ShowTargetTargetLevel == 1) then
				nameFrame:SetWidth(104);
			else
				nameFrame:SetWidth(128);
			end
		else
			statsFrame:SetWidth(160);
			statsFrameHealthBarPercent:Show();
			statsFrameManaBarPercent:Show();

			if (Perl_Config.ShowTargetTargetLevel == 1) then
				nameFrame:SetWidth(136);
			else
				nameFrame:SetWidth(160);
			end
		end

		Perl_Config.TargetBuffSize = tonumber(Perl_Config.TargetBuffSize) or 20;
		Perl_SetBuffSize(frame:GetName().."_", Perl_Config.TargetBuffSize, Perl_Config.TargetBuffSize * 1.2);
	end

	if (Perl_Config.ShowTargetTargetTarget == 1) then
		if (not Perl_TargetTargetTarget) then
			CreateFrame("Frame", "Perl_TargetTargetTarget", UIParent, "Perl_TargetTarget_Template");

			Perl_TargetTargetTarget:SetPoint("BOTTOMLEFT", Perl_TargetTarget_StatsFrame, "BOTTOMRIGHT", 5, 0);
			Perl_RestorePosition(Perl_TargetTargetTarget);
		end
	end

	Set(Perl_TargetTarget);
	if (Perl_TargetTargetTarget) then
		Set(Perl_TargetTargetTarget);
	end
end
