function Perl_OptionsFrame_SelectFrame(frame)
	Perl_FrameOptions_Frame:Show();

	if (frame == "player") then
		Perl_FrameOptions_Frame_Player:Show();
		Perl_FrameOptions_Frame_Party:Hide();
		Perl_FrameOptions_Frame_Raid:Hide();

	elseif (frame == "party") then
		Perl_FrameOptions_Frame_Player:Hide();
		Perl_FrameOptions_Frame_Party:Show();
		Perl_FrameOptions_Frame_Raid:Hide();

	elseif (frame == "raid") then
		Perl_FrameOptions_Frame_Player:Hide();
		Perl_FrameOptions_Frame_Party:Hide();
		Perl_FrameOptions_Frame_Raid:Show();
	end
end

function Perl_OptionsSetMyText(f, str)

	if (f and str) then
		local textFrame = getglobal(f:GetName().."Text");

		if (textFrame) then
			textFrame:SetText(getglobal(str));
			f.tooltipText = getglobal(str.."_DESC");

		elseif (f:GetFrameType() == "Button") then
			f:SetText(getglobal(str));
			f.tooltipText = getglobal(str.."_DESC");
		end

		setglobal(str, nil);
		setglobal(str.."_DESC", nil);
	end
end

function Perl_GetCheck(f)
	if (f:GetChecked()) then
	        return 1;
	else
	        return 0;
	end
end

function Perl_Options_EnableSibling(sibling, check2nd, check3rd)

	local siblingName = this:GetParent():GetName().."_"..sibling;
	local siblingFrame = getglobal(siblingName);
	local second = true;
	local condition = "and";

	if (type(check2nd) == "string") then
		condition = check2nd;
		check2nd = check3rd;
	end
	if (check2nd and type(check2nd) == "table") then
		second = check2nd:GetChecked();
	end

	local result;
	if (condition == "and") then
		result = (this:GetChecked() and second);
	elseif (condition == "or") then
		result = (this:GetChecked() or second);
	end

	if (siblingFrame) then
		if (siblingFrame:GetFrameType() == "Button") then
			if (result) then
				siblingFrame:Enable();
			else
				siblingFrame:Disable();
			end
		elseif (siblingFrame:GetFrameType() == "CheckButton") then
			local textFrame = getglobal(siblingFrame:GetName().."Text");
			if (result) then
				siblingFrame:Enable();
				textFrame:SetTextColor(NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b);
			else
				siblingFrame:Disable();
				textFrame:SetTextColor(GRAY_FONT_COLOR.r, GRAY_FONT_COLOR.g, GRAY_FONT_COLOR.b);
			end
		else
			DEFAULT_CHAT_FRAME:AddMessage("|c00FF0000X-Perl|r - No code to disable '"..siblingFrame:GetName().."' type: "..siblingFrame:GetFrameType());
		end
	else
		DEFAULT_CHAT_FRAME:AddMessage("|c00FF0000X-Perl|r - No sibling found called '"..siblingName.."'");
	end
end

function Perl_Options_IncrementSibling(sibling)
	local siblingName = this:GetParent():GetName().."_"..sibling;
	local siblingFrame = getglobal(siblingName);

	if (siblingFrame and siblingFrame:GetFrameType() == "EditBox") then
        	local n = tonumber(siblingFrame:GetText());
		n = n + 1;
		siblingFrame:SetText(n);
		return n;
	end
end

function Perl_Options_DecrementSibling(sibling)
	local siblingName = this:GetParent():GetName().."_"..sibling;
	local siblingFrame = getglobal(siblingName);

	if (siblingFrame and siblingFrame:GetFrameType() == "EditBox") then
        	local n = tonumber(siblingFrame:GetText());
		n = n - 1;
		siblingFrame:SetText(n);
		return n;
	end
end

-- Perl_Raid_OptionActions()
function Perl_Raid_OptionActions()
        Perl_Raid_Position();
end

function Perl_Options_OnUpdate()

	if (this.Fading) then
	        local alpha = this:GetAlpha();
	        if (this.Fading == "in") then
	                alpha = alpha + (arg1 * 2);
	                if (alpha > 1) then
	                        alpha = 1;
	                end
	        elseif (this.Fading == "out") then
	                alpha = alpha - (arg1 * 2);
	                if (alpha < 0) then
	                        alpha = 0;
	                end
	        end
	        this:SetAlpha(alpha);
	        if (alpha == 0) then
	                this.Fading = nil;
	                this:Hide();
	        elseif (alpha == 1) then
	                this.Fading = nil;
	        end
	end
end

function Perl_Options_SetBarTextureHighlight()

	local name = this:GetName();
	name = string.sub(name, 1, string.len(name) - 1);

	for i = 0,3 do
		local f = getglobal(name..i);

		if (f) then
			if (Perl_Config.BarTextures == i) then
				f:LockHighlight();
			else
				f:UnlockHighlight();
			end
		else
			ChatFrame7:AddMessage("No frame called "..name..i);
		end
	end
end

local Sliders = {};
function Perl_Options_MaxScaleSet()

	for i,slider in Sliders do
        	local old = slider:GetValue();
		local max = math.floor(Perl_Config.MaximumScale * 100 + 0.5);

        	getglobal(slider:GetName().."High"):SetText(string.format("%d%%", max));
        	slider:SetMinMaxValues(50, max);

		if (old > max) then
			slider:SetValue(max);
		end
	end
end

function Perl_Options_RegisterScalingSlider(slider)

	Sliders[slider:GetName()] = slider;

        getglobal(slider:GetName().."Low"):SetText("50%");
        getglobal(slider:GetName().."High"):SetText(string.format("%d%%", math.floor((Perl_Config.MaximumScale or 1.5) * 100 + 0.5)));

        slider:SetMinMaxValues(50, math.floor(Perl_Config.MaximumScale * 100 + 0.5));
        slider:SetValueStep(1);
end

function Perl_Popup(question, onAccept)
	StaticPopupDialogs["XPERL_QUESTION"] = {
	  text = question,
	  button1 = "Yes",
	  button2 = "No",
	  OnAccept = onAccept,
	  timeout = 0,
	  whileDead = 1,
	  hideOnEscape = 1,
	  showAlert = 1
	};
	StaticPopup_Show("XPERL_QUESTION");
end
