----------------------
-- Loading Function --
----------------------

local function SetFrameSides()
	if (XPerl_Assists_Frame.LastSetView and XPerl_Assists_Frame.LastSetView[1] == XPerl_Config.AssistsFrame and XPerl_Assists_Frame.LastSetView[2] == XPerl_Config.TargettingFrame) then
		-- Frames the same from last time
		return;
	end

	if (XPerl_Config.AssistsFrame == 1 or XPerl_Config.TargettingFrame == 1) then
        	XPerl_Assists_Frame:Show();

		XPerl_Target_Targetting_ScrollFrame:ClearAllPoints();
		XPerl_Target_Assists_ScrollFrame:ClearAllPoints();

		if (XPerl_Config.AssistsFrame == 1 and XPerl_Config.TargettingFrame == 1) then
			XPerl_Target_Targetting_ScrollFrame:SetPoint("TOPLEFT", 4, -5);
			XPerl_Target_Targetting_ScrollFrame:SetPoint("BOTTOMRIGHT", XPerl_Assists_Frame, "BOTTOM", -1, 5);
			XPerl_Target_Targetting_ScrollFrame:Show();

			XPerl_Target_Assists_ScrollFrame:SetPoint("TOPLEFT", XPerl_Assists_Frame, "TOP", 0, -5);
			XPerl_Target_Assists_ScrollFrame:SetPoint("BOTTOMRIGHT", -4, 5);
			XPerl_Target_Assists_ScrollFrame:Show();

			XPerlScrollSeperator:Show();
			XPerlScrollSeperator:ClearAllPoints();
			XPerlScrollSeperator:SetPoint("TOPLEFT", XPerl_Target_Targetting_ScrollFrame, "TOPRIGHT", 0, 0);
			XPerlScrollSeperator:SetPoint("BOTTOMRIGHT", XPerl_Target_Assists_ScrollFrame, "BOTTOMLEFT", 0, 0);
		else
			XPerlScrollSeperator:Hide();

			if (XPerl_Config.AssistsFrame == 1) then
				XPerl_Target_Assists_ScrollFrame:SetPoint("TOPLEFT", 4, -5);
				XPerl_Target_Assists_ScrollFrame:SetPoint("BOTTOMRIGHT", -4, 5);
				XPerl_Target_Assists_ScrollFrame:Show();
				XPerl_Target_Targetting_ScrollFrame:Hide();
			else
				XPerl_Target_Targetting_ScrollFrame:SetPoint("TOPLEFT", 4, -5);
				XPerl_Target_Targetting_ScrollFrame:SetPoint("BOTTOMRIGHT", -4, 5);
				XPerl_Target_Targetting_ScrollFrame:Show();
				XPerl_Target_Assists_ScrollFrame:Hide();
			end
		end
	else
        	XPerl_Assists_Frame:Hide();
	end

	XPerl_Assists_Frame.LastSetView = {XPerl_Config.AssistsFrame, XPerl_Config.TargettingFrame};
end

-- ToggleAssistsFrame()
function XPerl_ToggleAssistsFrame(param)
	if (param == "assists") then
		if (XPerl_Config.AssistsFrame == 1) then
			XPerl_Config.AssistsFrame = 0;
		else
			XPerl_Config.AssistsFrame = 1;
		end
	else
		if (XPerl_Config.TargettingFrame == 1) then
			XPerl_Config.TargettingFrame = 0;
		else
			XPerl_Config.TargettingFrame = 1;
		end
	end
end

-- Perl_AssistsView_Close
function XPerl_AssistsView_Open()
	XPerl_Config.AssistsFrame = 1;
	XPerl_Config.TargettingFrame = 1;
	SetFrameSides();
	return true;
end

function XPerl_AssistsView_Close()
	XPerl_Config.AssistsFrame = 0;
	XPerl_Config.TargettingFrame = 0;
	SetFrameSides();
end

-- SortByClass(t1, t2)
local function SortByClass(t1, t2)
	if (t1[2] == t2[2]) then
		return t1[1] < t2[1];
	else
		local _, me = UnitClass("player");
		local t1c = t1[2];
		local t2c = t2[2];
		if (t1c == me) then
			t1c = "A"..t1c;
		elseif (t1c ~= "") then
			t1c = "B"..t1c;
		else
			t1c = "Z";
		end
		if (t2c == me) then
			t2c = "A"..t2c;
		elseif (t2c ~= "") then
			t2c = "B"..t2c;
		else
			t1c = "Z";
		end

		return t1c..t1[1] < t2c..t2[1];
	end
end

function XPerl_MakeAssistsString(List, title)
	local lastClass;
	local any = false;
	local text = title;

	if (List ~= nil) then
		local nAssists = table.getn (List);
		if (nAssists > 0) then
			text = text.." "..nAssists;
		end
		text = text.."\13";

		table.sort(List, SortByClass);

		for i = 1,nAssists do
			local unit = List[i];

			if (not any) then
				if (unit[2] == "") then
					text = text.."|c00FF0000"..unit[1];
				else
					text = text..PerlColourTable[unit[2]]..unit[1];
				end
				lastClass = unit[2];
				any = true;
			else
				if (lastClass) then
					if (unit[2] == "" or lastClass ~= unit[2]) then
						lastClass = unit[2];

						if (unit[2] == "") then
							text = text.."\r|c00FF0000"..unit[1];
						else
							text = text.."\r"..PerlColourTable[unit[2]]..unit[1];
						end
					else
						text = text.." "..unit[1];
					end
				else
					text = text.." "..unit[1];

					lastClass = unit[2];
				end
			end
		end
	end

	return (text);
end

local function FillList(List, cFrame, title)
	local text = XPerl_MakeAssistsString(List, title)
	getglobal("XPerl_Target_Assists_ScrollChild_"..cFrame.."Text"):SetText(text);
end

-- XPerl_ShowAssists()
function XPerl_ShowAssists()
	SetFrameSides();

	if (XPerl_Config.AssistsFrame == 1 or XPerl_Config.TargettingFrame == 1) then
		XPerl_Target_Assists_ScrollChild_Targetting:SetWidth(XPerl_Target_Targetting_ScrollFrame:GetWidth() / XPerl_Target_Targetting_ScrollFrame:GetEffectiveScale());
		XPerl_Target_Assists_ScrollChild_Assists:SetWidth(XPerl_Target_Assists_ScrollFrame:GetWidth() / XPerl_Target_Assists_ScrollFrame:GetEffectiveScale());

		if (XPerl_Config.AssistsFrame == 1 and XPerl_Assists_Frame.assists ~= nil) then
			FillList(XPerl_Assists_Frame.assists, "Assists", PERL_TOOLTIP_ASSISTING);
		end

		if (XPerl_Config.TargettingFrame == 1 and XPerl_Assists_Frame.targetting ~= nil) then
			local title;
			if (table.getn(XPerl_Assists_Frame.targetting) > 0 and XPerl_Assists_Frame.targetting[1][2] == "") then
				title = PERL_TOOLTIP_ENEMYONME;
			else
				if (XPerl_Config.TargetCountersSelf == 0) then
					title = PERL_TOOLTIP_ALLONME;
				else
					title = PERL_TOOLTIP_HEALERS;
				end
			end

			FillList(XPerl_Assists_Frame.targetting, "Targetting", title);
		end
	end

end

function XPerl_Assists_MouseDown(button,param)
	if (button == "LeftButton") then
		if (not XPerl_Config or not XPerl_Config.AssistPinned) then
			if (param and (param == "TOPLEFT" or param == "BOTTOMLEFT" or param == "BOTTOMRIGHT")) then
				XPerl_Assists_Frame:StartSizing(param);
			else
				XPerl_Assists_Frame:StartMoving();
			end
		end

	elseif (button == "RightButton") then
		if (string.find (this:GetName(), "Perl_Target_Assists_ScrollChild_Targetting")) then
			param = "targetFrame";
		end

		if (param and param == "targetFrame") then
			if (XPerl_Config.TargetCountersSelf == 1) then
				XPerl_Config.TargetCountersSelf = 0;
			else
				XPerl_Config.TargetCountersSelf = 1;
			end
		end
	end
end

function XPerl_Assists_MouseUp(button)
	XPerl_Assists_Frame:StopMovingOrSizing();
end

-- Events
function XPerl_Assists_OnEvent()
	if (event == "PLAYER_TARGET_CHANGED") then
		XPerl_UpdateAssists();
		XPerl_ShowAssists();
	end
end

local UpdateTime = 0;
function XPerl_Assists_OnUpdate()

	UpdateTime = arg1 + UpdateTime;
	if (UpdateTime >= 0.2) then
	        XPerl_UpdateAssists();
		XPerl_ShowAssists();
		UpdateTime = 0;
	end
end

---------------------------------
-- Targetting counters         --
---------------------------------

local function Perl_FoundEnemyBefore(FoundEnemy, name)
	for i = 1, table.getn(FoundEnemy) do
		local previous = FoundEnemy[i];
		if (UnitIsUnit(previous.."target", name.."target")) then
			return true;
		end
	end
	return false;
end

local function Perl_AddEnemy(anyEnemy, FoundEnemy, name)
	--if (UnitCanAttack("player", name.."target") and UnitIsUnit("player", name.."targettarget")) then
	if (not UnitIsFriend("player", name.."target") and UnitIsUnit("player", name.."targettarget")) then
		if (not Perl_FoundEnemyBefore(FoundEnemy, name)) then
			table.insert(FoundEnemy, name);
			table.insert(XPerl_Assists_Frame.targetting, {UnitName(name.."target"), ""});
			return true;
		end
	end
	return false;
end

function XPerl_UpdateAssists()

	if (XPerl_Config.TargetCounters == 0) then
		if (Perl_Target_AssistFrame) then Perl_Target_AssistFrame:Hide(); end;
		if (Perl_Player_TargettingFrame) then Perl_Player_TargettingFrame:Hide(); end;
		return;
	end

	local assists = 0;
	local targetting = 0;
	local anyEnemy = false;
	local FoundEnemy = {};
	local start,i,total,prefix,name,petname,raidMembers;
	local targetname;
	raidMembers = 0;

	if (UnitInRaid("player")) then
		start = 1;
		prefix = "raid";
		total = GetNumRaidMembers();
	else
		start = 0;
		prefix = "party";
		total = 4;
	end

	XPerl_Assists_Frame.assists = {};
	XPerl_Assists_Frame.targetting = {};

	targetname = UnitName("target");
	for i = start,total do
		if (i == 0) then
			name = "player";
		else
			name = prefix..i;
		end

		if (UnitName(name) and not UnitIsDeadOrGhost(name)) then
			local class, engClass = UnitClass(name);
			raidMembers = raidMembers + 1;

			if (targetname) then
				if (UnitIsUnit("target", name.."target")) then
					assists = assists + 1;
					table.insert (XPerl_Assists_Frame.assists, {UnitName(name), engClass});
				end
			end

			-- 0 for Anyone, 1 for Healers
			if (XPerl_Config.TargetCountersSelf == 0 or (engClass == "PRIEST" or engClass == "SHAMAN" or engClass == "PALADIN" or engClass == "DRUID")) then
				if (UnitIsUnit("player", name.."target")) then
					targetting = targetting + 1;
					table.insert(XPerl_Assists_Frame.targetting, {UnitName(name), engClass});
				end
			end
		end
	end

	if (XPerl_Config.TargetCountersEnemy == 1) then		-- Count enemy targetting us?
		for i = start,total do
			if (i == 0) then
				name = "player";
				petname = "pet";
			else
				name = prefix..i;
				petname = prefix.."pet"..i;
			end

			if (UnitExists(name)) then
				if (Perl_AddEnemy(anyEnemy, FoundEnemy, name)) then
					anyEnemy = true;
					targetting = targetting + 1;
				end
				if (UnitExists(petname)) then
					if (Perl_AddEnemy(anyEnemy, FoundEnemy, petname)) then
						anyEnemy = true;
						targetting = targetting + 1;
					end
				end
			end
		end
	end

	if (Perl_Player_Frame and Perl_Player_TargettingFrame) then
		local conf = Perl_Config or XPerl_Config;
		conf = conf.BorderColour;

		if (anyEnemy) then
			Perl_Player_TargettingFrame:SetBackdropBorderColor(1, 0.2, 0.2, conf.a);
		else
			Perl_Player_TargettingFrame:SetBackdropBorderColor(conf.r, conf.g, conf.b, conf.a);
		end

		if (targetting == 0) then
			Perl_Player_TargettingFrame:SetTextColor(1,0.5,0.5);
		elseif (targetting > 5) then
			Perl_Player_TargettingFrame:SetTextColor(0.5,1,0.5);
		else
			Perl_Player_TargettingFrame:SetTextColor(0.5,0.5,1);
		end

		Perl_Player_TargettingFrame:SetText(targetting);

		if (not Perl_Player_TargettingFrame:IsShown()) then
			Perl_Player_TargettingFrame:Show();
		end
	end

	if (Perl_Target_Frame and Perl_Target_AssistFrame) then
		if (assists < 2) then
			Perl_Target_AssistFrame:SetTextColor(1,0.5,0.5);
		elseif (assists > (raidMembers / 2)) then
			Perl_Target_AssistFrame:SetTextColor(0.5,1,0.5);
		else
			Perl_Target_AssistFrame:SetTextColor(0.5,0.5,1);
		end

		if (targetname) then
			Perl_Target_AssistFrame:SetText(assists);
		end

		if (not Perl_Target_AssistFrame:IsShown()) then
			Perl_Target_AssistFrame:Show();
		end
	end
end
